/*
Prancha Livre de Comunicao
Copyright (C) 2005 Percy Nohama <percy@ppgia.pucpr.br>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// PranchaVirtualDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PranchaVirtual.h"
#include "PranchaVirtualDlg.h"
#include "Picture.h"
#include "PerfilDlg.h"
#include "OpcaoDlg.h"

//Copiar a pastas e arquivos
#include <fstream.h>	
#include <shlobj.h>

// Sintetizador de voz
#include <mmsystem.h>
#include <initguid.h>
#include <objerror.h>

#ifdef DIRECTSOUND
#include <dsound.h>
#endif // DIRECTSOUND


#include <c:\speech.h>	  

ITTSCentral *pITTSCentral;
IAudioMultiMediaDevice *pIAMM;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	//************************************************************
	//	Associa o ID dos componentes grficos com a varivel	 *
	//************************************************************

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//************************************************************
	//*	Associa o ID dos componentes grficos com a funo		 *
	//************************************************************

	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPranchaVirtualDlg dialog

CPranchaVirtualDlg::CPranchaVirtualDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPranchaVirtualDlg::IDD, pParent)
{
	//***********************
	//*		Construtor		*
	//***********************

	// Inicializa as variveis

	//{{AFX_DATA_INIT(CPranchaVirtualDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPranchaVirtualDlg::DoDataExchange(CDataExchange* pDX)
{
	//************************************************************
	//	Associa o ID dos componentes grficos com a varivel	 *
	//************************************************************

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPranchaVirtualDlg)
	DDX_Control(pDX, IDC_STATIC1, m_area);
	DDX_Control(pDX, IDC_BIT6, m_bit6);
	DDX_Control(pDX, IDC_BIT5, m_bit5);
	DDX_Control(pDX, IDC_BIT4, m_bit4);
	DDX_Control(pDX, IDC_BIT3, m_bit3);
	DDX_Control(pDX, IDC_BIT2, m_bit2);
	DDX_Control(pDX, IDC_BIT1, m_bit1);
	DDX_Control(pDX, IDC_BUTTON18, m_b18);
	DDX_Control(pDX, IDC_BUTTON17, m_b17);
	DDX_Control(pDX, IDC_BUTTON16, m_b16);
	DDX_Control(pDX, IDC_BUTTON15, m_b15);
	DDX_Control(pDX, IDC_BUTTON14, m_b14);
	DDX_Control(pDX, IDC_BUTTON13, m_b13);
	DDX_Control(pDX, IDC_BUTTON12, m_b12);
	DDX_Control(pDX, IDC_BUTTON11, m_b11);
	DDX_Control(pDX, IDC_BUTTON10, m_b10);
	DDX_Control(pDX, IDC_BUTTON9, m_b9);
	DDX_Control(pDX, IDC_BUTTON8, m_b8);
	DDX_Control(pDX, IDC_BUTTON7, m_b7);
	DDX_Control(pDX, IDC_BUTTON6, m_b6);
	DDX_Control(pDX, IDC_BUTTON5, m_b5);
	DDX_Control(pDX, IDC_BUTTON4, m_b4);
	DDX_Control(pDX, IDC_BUTTON3, m_b3);
	DDX_Control(pDX, IDC_BUTTON2, m_b2);
	DDX_Control(pDX, IDC_BUTTON1, m_b1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPranchaVirtualDlg, CDialog)

	//************************************************************
	//*	Associa o ID dos componentes grficos com a funo		 *
	//************************************************************

	//{{AFX_MSG_MAP(CPranchaVirtualDlg)
	ON_WM_ERASEBKGND()
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_RBUTTONDOWN()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton)
 	ON_BN_CLICKED(IDC_BUTTON6, OnButton)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton)
 	ON_BN_CLICKED(IDC_BUTTON10, OnButton)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton)
	ON_BN_CLICKED(IDC_BUTTON12, OnButton)
	ON_BN_CLICKED(IDC_BUTTON13, OnButton)
	ON_BN_CLICKED(IDC_BUTTON14, OnButton)
	ON_BN_CLICKED(IDC_BUTTON15, OnButton)
 	ON_BN_CLICKED(IDC_BUTTON16, OnButton)
	ON_BN_CLICKED(IDC_BUTTON17, OnButton)
	ON_BN_CLICKED(IDC_BUTTON18, OnButton)
	ON_COMMAND(ID_OPES_LEGENDA, OnLegenda)
	ON_COMMAND(ID_NOVO, MenuInserir)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPranchaVirtualDlg message handlers

BOOL CPranchaVirtualDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, 1);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//***********************
	// Inicio da Prancha	*
	//***********************


// Armazena a resoluo da tela
	m_resx=GetSystemMetrics( SM_CXSCREEN);
	m_resy=GetSystemMetrics( SM_CYSCREEN);

// Seta a resolucao para 800x600
	Resolucao(800,600);

	config.legenda=1;
	config.interfac="principal";
	usuario[1].nome="Padro";

	m_posicao=0;
	m_pagina=1;
	sintativo=false;

// Ajusta a tela
	InterConf();

// Abre as configuraes
	IniAbrir();

// Exibe os botes da interface de usurios
	InterPerfil();
	return 1;   
}
void CPranchaVirtualDlg::Imagem2(CDC *pDC, CRect rectImagem)
{

	//*******************************
	// Desenho da IMAGEM INVLIDA	*
	//*******************************

		CDC dcMem;
		VERIFY( dcMem.CreateCompatibleDC(pDC));
		HBITMAP m_hbmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(), 
                                        MAKEINTRESOURCE(IDB_BITMAP2),
                                        IMAGE_BITMAP, 
                                        0,0, 
                                        LR_LOADMAP3DCOLORS);
		BITMAP   m_bmp;
		::GetObject(m_hbmp, sizeof(BITMAP), &m_bmp);
		HBITMAP* m_hbmp2 = (HBITMAP*) ::SelectObject(dcMem.m_hDC, m_hbmp);
		pDC->StretchBlt(rectImagem.left   ,		// inicio x
							rectImagem.top,		// inicio y
							rectImagem.Width(),	// largura
							rectImagem.Height(),// altura
			&dcMem, 0, 0, m_bmp.bmWidth, m_bmp.bmHeight,
			SRCCOPY);
 		::SelectObject(dcMem.m_hDC, m_hbmp2);
		
}
void CPranchaVirtualDlg::Imagem(CDC *pDC, CString m_arquivo, CRect rectImagem)
{
	//*******************************
	// Desenha uma IMAGEM VLIDA	*
	//*******************************

	CDC memDC;
	memDC.CreateCompatibleDC(pDC);
	IPicture *IPic; 
	IStream *IStr; 
	BOOL bResult; 
	HANDLE hFile=NULL; 
	DWORD dwFileSize,dwByteRead; 

// Cria um arquivo
	hFile=CreateFile(m_arquivo,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL); 

// Pega o tamanho
	dwFileSize=GetFileSize(hFile,NULL); 
	HGLOBAL hGlobal = GlobalAlloc(GMEM_MOVEABLE, dwFileSize); 
	LPVOID pvData = NULL; 
	pvData = GlobalLock(hGlobal);

// Faz a leitura do arquivo
	ReadFile(hFile,pvData,dwFileSize,&dwByteRead,NULL);
	GlobalUnlock(hGlobal); 
	CreateStreamOnHGlobal(hGlobal, TRUE, &IStr); 
	bResult=OleLoadPicture(IStr,dwFileSize,TRUE,IID_IPicture,(LPVOID*)&IPic); 

// Pega o tamanho da imagem
	OLE_XSIZE_HIMETRIC hmWidth;
	OLE_YSIZE_HIMETRIC hmHeight;
	IPic->get_Width(&hmWidth); 
	IPic->get_Height(&hmHeight); 

// transforma o tamanho em pixels
	float ximagem =  MulDiv(hmWidth,	pDC->GetDeviceCaps(LOGPIXELSX), 2450);
	float yimagem =  MulDiv(hmHeight,	pDC->GetDeviceCaps(LOGPIXELSY), 2450);

// pega o tamanho do boto
	float xbotao=rectImagem.Width();
	float ybotao=rectImagem.Height();

	float xfim=5;
	float yfim=5;
// Imagem quadrada
	if ((ximagem-yimagem<10)&&(ximagem-yimagem>-10)){
		float fator=xbotao/ximagem;
		xfim=fator*ximagem;
		fator=ybotao/yimagem;
		yfim=fator*yimagem;
		}
// Imagem paisagem
	else if(ximagem>yimagem){
		float fator=xbotao/ximagem;
		xfim=fator*ximagem;
		yfim=fator*yimagem;
		rectImagem.top+=(ybotao-yfim)/2;
		}
// Imagem retrato
	else{
		float fator=ybotao/yimagem;
		xfim=fator*ximagem;
		yfim=fator*yimagem;
		rectImagem.left+=(xbotao-xfim)/2;
		}
// Distribui as imagens conforme o formato escolhido
	if(m_tipo=="Estender"){
// Amplia a imagem do tamanho da tela
		rectImagem.top=0;
		rectImagem.left=0;	
		bResult=IPic->Render(pDC->GetSafeHdc(),
				rectImagem.left,
				rectImagem.top,
				rectImagem.Width(),
				rectImagem.Height(),
				0,hmHeight,hmWidth,-hmHeight,NULL); 
		}
	
	else if(m_tipo=="LLado"){
// Coloca imagens repetidas at a tela ser preenchida
		CRect rect=rectImagem;
		rectImagem.top=0;
		rectImagem.left=0;
		rectImagem.bottom=yimagem;
		rectImagem.right=ximagem;
		int xo,yo;
		for (yo = 0; yo < rect.Height(); yo += yimagem){
			for (xo = 0; xo < rect.Width(); xo += ximagem)
				bResult=IPic->Render(pDC->GetSafeHdc(),xo, yo,ximagem,yimagem,0,hmHeight,hmWidth,-hmHeight,NULL); 
			bResult=IPic->Render(pDC->GetSafeHdc(),xo, yo,ximagem,yimagem,0,hmHeight,hmWidth,-hmHeight,NULL); 
			}
		bResult=IPic->Render(pDC->GetSafeHdc(),xo, yo,xfim,yfim,0,hmHeight,hmWidth,-hmHeight,NULL); 
		}
// Centralizado
	else if(m_tipo=="Centro"){
		bResult=IPic->Render(pDC->GetSafeHdc(),
			(rectImagem.right-ximagem)/2,
			(rectImagem.bottom-yimagem)/2,
			ximagem,
			yimagem,
			0,hmHeight,hmWidth,-hmHeight,NULL); 

		}
// Imagem do boto
	else{
		bResult=IPic->Render(pDC->GetSafeHdc(),
			rectImagem.left,
			rectImagem.top,
			xfim,
			yfim,
			0,hmHeight,hmWidth,-hmHeight,NULL); 

		}
	IPic->Release(); 
	CloseHandle(hFile);

}

void CPranchaVirtualDlg::OnFalar()
{
	//***************************
	// Inicia o sintetizador	*
	//***************************

	UpdateData();
// Agrupa o  texto dos botes
	CString frase,temp;
	m_bit1.GetWindowText(temp);
	if(m_bit1.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit2.GetWindowText(temp);
	if(m_bit2.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit3.GetWindowText(temp);
	if(m_bit3.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit4.GetWindowText(temp);
	if(m_bit4.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit5.GetWindowText(temp);
	if(m_bit5.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit6.GetWindowText(temp);
	if(m_bit6.m_arquivo!="")frase+=temp;
// Envia ao sintetizador
		
	if(SintetizadorAbrir(frase)==false){
		MessageBox("No foi possvel iniciar o sintetizador.","ERRO",MB_ICONERROR);
		}
	
}
 
void CPranchaVirtualDlg::IniAbrir() 
{
	//***************************************
	// Abre as configuraes do aplicativo	*
	//***************************************

// inicializa as configuraes
	config.autoclique=false;
	config.varredura=false;
	config.legenda=1;
	config.atraso=1;
	config.tempo=10;	
	m_vver=0;
	m_vhor=0;
	m_vpos=1;

	CString tex;
	CRect rect;
	HWND hWnd;
	hWnd=::GetActiveWindow();
	GetWindowRect(&rect);


// Pega os usurios do arquivo "config.ini"
	TCHAR temp[500] = {0}; //   [Ttulo] texto =  texto2 ,var,tam,   arquivo
	GetPrivateProfileString("Usurios da Prancha Virtual","usurios"  ,"Padro",temp,500,".\\config.ini");
	CString usr,usr2;
	CString pasta;
	usr=temp;
	usr2=temp;
	config.usrcont=1;

// Acha o diretorio da instalao	
	char buf[1000];
	::GetModuleFileName(AfxGetApp()->m_hInstance, buf, sizeof(buf));
	m_diretorio=buf;
	m_diretorio.Delete(m_diretorio.ReverseFind('\\')+1,m_diretorio.GetLength()-m_diretorio.ReverseFind('\\')-1);

// Pega o diretrio atual
	if(m_diretorio.Find("Debug",0)>0){
		m_diretorio.Delete(m_diretorio.GetLength()-6,6);
		}
// Caminho do Desktop
//	char Path[_MAX_PATH];
//	SHGetSpecialFolderPath(    NULL, Path, CSIDL_DESKTOPDIRECTORY, FALSE);	
	m_desktop=m_diretorio;
	m_desktop.Delete(m_desktop.Find(":",0)+1,m_desktop.GetLength()-m_desktop.Find(":",0)-1);

//Corre usurio por usurio e armazena os dados de cada um
	while(usr.ReverseFind('*')>0){
		usr.Delete(usr.Find("*",0),usr.GetLength()-usr.Find("*",0));
		usuario[config.usrcont].nome=usr;
		pasta=m_diretorio;
		pasta+=usr;
		pasta+="\\config.ini";
		GetPrivateProfileString("Configuraes da Prancha Virtual","perfil","xxx",temp,500,pasta);
		usuario[config.usrcont].caminho=temp;
		if(usuario[config.usrcont].caminho.Find(":\\",1)<0){
			usuario[config.usrcont].caminho=m_diretorio;
			usuario[config.usrcont].caminho+=temp;
			}
		usr2.Delete(0,usr2.Find("*",0)+1);
		usr=usr2;
		config.usrcont++;
		}
// ltimo usuario
	if(usr.GetLength()>0){
		usuario[config.usrcont].nome=usr;
		pasta=m_diretorio;
		pasta+=usr;
		pasta+="\\config.ini";
		GetPrivateProfileString("Configuraes da Prancha Virtual","perfil","x",temp,500,pasta);
		usuario[config.usrcont].caminho=temp;
		if(usuario[config.usrcont].caminho.Find(":\\",1)<0){
			usuario[config.usrcont].caminho=m_diretorio;
			usuario[config.usrcont].caminho+=temp;
			}
		}
// Aplica as configuraes do ltimo usurio
	UsuConf(usuario[1].nome);

// Limpa a rea de predio
	imagem[13].caminho="";
	imagem[14].caminho="";
	imagem[15].caminho="";
	imagem[16].caminho="";
	imagem[17].caminho="";
	imagem[18].caminho="";
	}
void CPranchaVirtualDlg::IniFechar() 
{
	//***************************************
	// Salva a lista no arquivo config.ini	*
	//***************************************
	
	CStdioFile arquivo;
	CString g,dados;
	CString pp;
	CString usuarios;
	CString pasta=m_diretorio+"config.ini";
	int pos=1;

// Salva os usurios
	do{
		usuarios+=usuario[pos].nome;
		usuarios+="*";
		pos++;
		}while(usuario[pos].nome.GetLength()>0);

	usuarios.Delete(usuarios.GetLength()-1,1);
	WritePrivateProfileString("Usurios da Prancha Virtual","usurios",usuarios,pasta);

// Pega a localizao do arquivo
	pasta=m_diretorio;
	pasta+=usuario[1].nome+"\\config.ini";

// Salva no arquivo o altoclique, varredura, o tempo, o fundo, o tipo, a cor, a legenda
	dados.Format("%d",config.autoclique);
	WritePrivateProfileString("Configuraes da Prancha Virtual","autoclique",dados,pasta);

	dados.Format("%d",config.varredura);
	WritePrivateProfileString("Configuraes da Prancha Virtual","varredura",dados,pasta);

	dados.Format("%d",config.atraso);
	WritePrivateProfileString("Configuraes da Prancha Virtual","atraso"    ,dados,pasta);

	dados=config.fundo;
	WritePrivateProfileString("Configuraes da Prancha Virtual","fundo"  ,dados,pasta);

	dados=config.tipo;
	WritePrivateProfileString("Configuraes da Prancha Virtual","tipo"  ,dados,pasta);

	dados.Format("0x0%x",config.cor);
	WritePrivateProfileString("Configuraes da Prancha Virtual","cor"  ,dados,pasta);

	dados.Format("%d",config.legenda);
	WritePrivateProfileString("Configuraes da Prancha Virtual","legenda"  ,dados,pasta);

	dados.Format("%d",config.som);
	WritePrivateProfileString("Configuraes da Prancha Virtual","som"  ,dados,pasta);

	dados.Format("%d",config.masculino);
	WritePrivateProfileString("Configuraes da Prancha Virtual","homem"  ,dados,pasta);

// Salva a interface do usurio atual
	if(arquivo.Open(m_diretorio+usuario[1].nome+"\\interface.cfg",CFile::modeCreate | CFile::modeWrite)){
		CString texto,temp;
		int t=1;
		do{
			if(t>12 && t<19){
				imagem[t].nome="-";
				imagem[t].caminho="";
				}
			texto+=imagem[t].nome;
			texto+="*";
			texto+=imagem[t].caminho;
			texto+="\n";
			pp=texto;
			t++;
			}while(t<=67);
//			MessageBox(imagem[13].caminho);
		arquivo.Write(texto,texto.GetLength());
		arquivo.Close();
		}
	for(int i=1;i<=6;i++){
// Salva os grupos
		g.Format("%d",i);

		if(arquivo.Open(m_diretorio+usuario[1].nome+"\\grupo"+g+".cfg",CFile::modeCreate | CFile::modeWrite)){//abre  arquivo
			
			CString texto,temp;
			int t=1;
			while(grupo[i][t].nome!=""){
//				MessageBox(grupo[i][t].nome);
				temp.Format("%d",grupo[i][t].codigo);
				texto+=temp;
				texto+=" ";
				texto+=grupo[i][t].nome;
				texto+=" ";
				temp.Format("%d",grupo[i][t].contador);
				texto+=temp;
				texto+="-";
				texto+=grupo[i][t].historico;
				texto+="*";
				texto+=grupo[i][t].caminho;
				texto+="\n";
				t++;
				pp=texto;
				};
			arquivo.Write(texto,texto.GetLength());
			arquivo.Close();
			}
	
	}	
}

void CPranchaVirtualDlg::InterConf()
{
	//*******************************
	// Interface das Configuraes	*
	//*******************************

// Limpa os botes da janela
	Limpar();

	m_bit1.SetFocus();

// Seta o ttulo da janela
	SetWindowText("Prancha Virtual");
	CRect rect,rect2;
	GetWindowRect( rect );
	GetDesktopWindow()->GetWindowRect( &rect2); 

	int lartela=rect2.Height();
	int alttela=rect2.Width();

// Posiciona a janela
	::SetWindowPos(m_hWnd,NULL,0,0,alttela,lartela,SWP_SHOWWINDOW); 
	
// Ajusta o tamanho da tela do Aplicativo
	tela.esq=lartela/25;
	tela.topo=alttela/4.8;
	tela.lar=lartela/5.2;
	tela.alt=alttela/7;


// 1a fila
	m_b1.SetWindowPos(NULL,tela.esq,tela.topo,tela.lar,tela.alt,NULL);		tela.esq+=tela.lar+tela.lar/10;
	m_b2.SetWindowPos(NULL,tela.esq,tela.topo,tela.lar,tela.alt,NULL);		tela.esq+=tela.lar+tela.lar/10;
	m_b3.SetWindowPos(NULL,tela.esq,tela.topo,tela.lar,tela.alt,NULL);		tela.esq+=tela.lar+tela.lar/10;
	m_b4.SetWindowPos(NULL,tela.esq,tela.topo,tela.lar,tela.alt,NULL);		tela.esq+=tela.lar+tela.lar/10;
	m_b5.SetWindowPos(NULL,tela.esq,tela.topo,tela.lar,tela.alt,NULL);		tela.esq+=tela.lar+tela.lar/10;
	m_b6.SetWindowPos(NULL,tela.esq,tela.topo,tela.lar,tela.alt,NULL);		tela.esq=lartela/25;		tela.topo+=alttela/60;

// 2a fila
	m_b7.SetWindowPos(NULL,tela.esq,tela.topo+tela.alt,tela.lar,tela.alt,NULL); 	tela.esq+=tela.lar+tela.lar/10;
	m_b8.SetWindowPos(NULL,tela.esq,tela.topo+tela.alt,tela.lar,tela.alt,NULL); 	tela.esq+=tela.lar+tela.lar/10;
	m_b9.SetWindowPos(NULL,tela.esq,tela.topo+tela.alt,tela.lar,tela.alt,NULL); 	tela.esq+=tela.lar+tela.lar/10;
	m_b10.SetWindowPos(NULL,tela.esq,tela.topo+tela.alt,tela.lar,tela.alt,NULL);	tela.esq+=tela.lar+tela.lar/10;
	m_b11.SetWindowPos(NULL,tela.esq,tela.topo+tela.alt,tela.lar,tela.alt,NULL);	tela.esq+=tela.lar+tela.lar/10;
	m_b12.SetWindowPos(NULL,tela.esq,tela.topo+tela.alt,tela.lar,tela.alt,NULL);	tela.esq=lartela/25;		tela.topo+=alttela/60;

// 3a fila
	m_b13.SetWindowPos(NULL,tela.esq,tela.topo+2*tela.alt,tela.lar,tela.alt,NULL);	tela.esq+=tela.lar+tela.lar/10;
	m_b14.SetWindowPos(NULL,tela.esq,tela.topo+2*tela.alt,tela.lar,tela.alt,NULL);	tela.esq+=tela.lar+tela.lar/10;
	m_b15.SetWindowPos(NULL,tela.esq,tela.topo+2*tela.alt,tela.lar,tela.alt,NULL);	tela.esq+=tela.lar+tela.lar/10;
	m_b16.SetWindowPos(NULL,tela.esq,tela.topo+2*tela.alt,tela.lar,tela.alt,NULL);	tela.esq+=tela.lar+tela.lar/10;
	m_b17.SetWindowPos(NULL,tela.esq,tela.topo+2*tela.alt,tela.lar,tela.alt,NULL);	tela.esq+=tela.lar+tela.lar/10;
	m_b18.SetWindowPos(NULL,tela.esq,tela.topo+2*tela.alt,tela.lar,tela.alt,NULL);	tela.esq=lartela/50;	tela.topo=alttela/60;
	
// rea da Frase
	m_bit1.SetWindowPos(NULL,2*tela.esq,2*tela.topo,tela.lar,tela.alt*1.1,NULL);      
	m_bit2.SetWindowPos(NULL,3*tela.esq+1*tela.lar,2*tela.topo,tela.lar,tela.alt*1.1,NULL);
	m_bit3.SetWindowPos(NULL,4*tela.esq+2*tela.lar,2*tela.topo,tela.lar,tela.alt*1.1,NULL);
	m_bit4.SetWindowPos(NULL,5*tela.esq+3*tela.lar,2*tela.topo,tela.lar,tela.alt*1.1,NULL);
	m_bit5.SetWindowPos(NULL,6*tela.esq+4*tela.lar,2*tela.topo,tela.lar,tela.alt*1.1,NULL);
	m_bit6.SetWindowPos(NULL,7*tela.esq+5*tela.lar,2*tela.topo,tela.lar,tela.alt*1.1,NULL);
 
	tela.esq=lartela/80;
	m_area.SetWindowPos(NULL,tela.esq,tela.topo,lartela*1.3,tela.alt*1.2,NULL);
	
// Ajusta no MENU a legenda
	UpdateData();
	
	HMENU hMenu;
	hMenu = ::GetMenu(this->GetSafeHwnd());
	HMENU hSubMenu;
	hSubMenu = ::GetSubMenu(hMenu, 0);

// No utilizado
// Sinaliza a legenda no menu em checked e unchecked
	if(config.legenda==1)CheckMenuItem(hMenu,ID_OPES_LEGENDA,MF_CHECKED );
	else CheckMenuItem(hMenu,ID_OPES_LEGENDA,MF_UNCHECKED );

	UpdateData(FALSE);
	UpdateData();
//		Ocultar();
	UpdateData(FALSE);

}


void CPranchaVirtualDlg::InterGrupo()
{
	//*******************************
	// Atualiza a tela com o grupo	*
	//******************************
		 
	m_bit1.SetFocus();	
	config.interfac="classe";
	UpdateData();

	// Limpa os botes da janela
	Limpar();

// Oculta os botes vazios
	Ocultar();
	
// Ajusta a lista para a pgina
	int pag=0;
	for(int i=2;i<=m_pagina;i++){
		pag+=15;

		}
	bool pag1=false;
	m_b1.SetImagem(imagem[52].caminho);	m_b1.SetWindowText(imagem[52].nome);

// Se a pgina for maior que 1 no existe o boo voltar
	if(m_pagina==1){
 		m_b2.SetImagem(grupo[m_grupoativo][pag+pag1+1].caminho);	m_b2.SetWindowText(grupo[m_grupoativo][pag+pag1+1].nome);
		pag1=true;
		int z=pag+pag1+17;
 		if(grupo[m_grupoativo][pag+pag1+17].caminho.GetLength()==0 && grupo[m_grupoativo][pag+pag1+16].caminho.GetLength()>0){
			m_b18.SetImagem(grupo[m_grupoativo][pag+pag1+16].caminho);	m_b18.SetWindowText(grupo[m_grupoativo][pag+pag1+16].nome);
			}
		else if(grupo[m_grupoativo][pag+18].caminho.GetLength()>0){
			m_b18.SetImagem(imagem[53].caminho);	m_b18.SetWindowText(imagem[53].nome);
			}
		}
	else {
		pag+=1;
		m_b2.SetImagem(imagem[2].caminho);	m_b2.SetWindowText(imagem[2].nome);
		if(grupo[m_grupoativo][pag+pag1+17].caminho.GetLength()==0 && grupo[m_grupoativo][pag+pag1+16].caminho.GetLength()>0){
			m_b18.SetImagem(grupo[m_grupoativo][pag+pag1+16].caminho);	m_b18.SetWindowText(grupo[m_grupoativo][pag+pag1+16].nome);
			}
		else if(grupo[m_grupoativo][pag+pag1+18].caminho.GetLength()>0){
			m_b18.SetImagem(imagem[53].caminho);	m_b18.SetWindowText(imagem[53].nome);
			}
 		}
// Mostra o resto dos botes
	m_b3.SetImagem(grupo[m_grupoativo][pag+pag1+1].caminho);	m_b3.SetWindowText(grupo[m_grupoativo][pag+pag1+1].nome);
	m_b4.SetImagem(grupo[m_grupoativo][pag+pag1+2].caminho);	m_b4.SetWindowText(grupo[m_grupoativo][pag+pag1+2].nome);
	m_b5.SetImagem(grupo[m_grupoativo][pag+pag1+3].caminho);	m_b5.SetWindowText(grupo[m_grupoativo][pag+pag1+3].nome);
	m_b6.SetImagem(grupo[m_grupoativo][pag+pag1+4].caminho);	m_b6.SetWindowText(grupo[m_grupoativo][pag+pag1+4].nome);
	m_b7.SetImagem(grupo[m_grupoativo][pag+pag1+5].caminho);	m_b7.SetWindowText(grupo[m_grupoativo][pag+pag1+5].nome);
	m_b8.SetImagem(grupo[m_grupoativo][pag+pag1+6].caminho);	m_b8.SetWindowText(grupo[m_grupoativo][pag+pag1+6].nome);
	m_b9.SetImagem(grupo[m_grupoativo][pag+pag1+7].caminho);	m_b9.SetWindowText(grupo[m_grupoativo][pag+pag1+7].nome);
	m_b10.SetImagem(grupo[m_grupoativo][pag+pag1+8].caminho);	m_b10.SetWindowText(grupo[m_grupoativo][pag+pag1+8].nome);
	m_b11.SetImagem(grupo[m_grupoativo][pag+pag1+9].caminho);	m_b11.SetWindowText(grupo[m_grupoativo][pag+pag1+9].nome);
	m_b12.SetImagem(grupo[m_grupoativo][pag+pag1+10].caminho);	m_b12.SetWindowText(grupo[m_grupoativo][pag+pag1+10].nome);
	m_b13.SetImagem(grupo[m_grupoativo][pag+pag1+11].caminho);	m_b13.SetWindowText(grupo[m_grupoativo][pag+pag1+11].nome);
	m_b14.SetImagem(grupo[m_grupoativo][pag+pag1+12].caminho);	m_b14.SetWindowText(grupo[m_grupoativo][pag+pag1+12].nome);
	m_b15.SetImagem(grupo[m_grupoativo][pag+pag1+13].caminho);	m_b15.SetWindowText(grupo[m_grupoativo][pag+pag1+13].nome);
	m_b16.SetImagem(grupo[m_grupoativo][pag+pag1+14].caminho);	m_b16.SetWindowText(grupo[m_grupoativo][pag+pag1+14].nome);
	m_b17.SetImagem(grupo[m_grupoativo][pag+pag1+15].caminho);	m_b17.SetWindowText(grupo[m_grupoativo][pag+pag1+15].nome);
//MessageBox(grupo[m_grupoativo][pag+pag1+17].caminho);MessageBox(grupo[m_grupoativo][pag+pag1+18].caminho);

	UpdateData(FALSE);
}
void CPranchaVirtualDlg::InterOpcao()
{

	//***********************
	// Interface das Opes	*
	//***********************
	
	m_bit1.SetFocus();	
// Limpa os botes da janela
	Limpar();

	m_grupoativo=7;
	config.interfac="Opcao";
	UpdateData();

// Oculta os botes vazios
	Ocultar();

// Adiciona as imagens e o texto da interface opo
 	m_b1.SetImagem(imagem[2].caminho);		m_b1.SetWindowText(imagem[2].nome);
 	
	if(config.legenda==1){
		m_b2.SetImagem(imagem[21].caminho);	m_b2.SetWindowText(imagem[21].nome);
		}
	else{
		m_b2.SetImagem(imagem[22].caminho);	m_b2.SetWindowText(imagem[22].nome);
		}

	m_b3.SetImagem(imagem[23].caminho);		m_b3.SetWindowText(imagem[23].nome);

	m_b4.SetImagem(imagem[24].caminho);		m_b4.SetWindowText(imagem[24].nome);

	if(config.tipo=="Centro"){
		m_b5.SetImagem(imagem[25].caminho);	m_b5.SetWindowText(imagem[25].nome);
		}
	else if(config.tipo=="LLado"){
		m_b5.SetImagem(imagem[26].caminho);	m_b5.SetWindowText(imagem[26].nome);
		}
	else if(config.tipo=="Estender"){
		m_b5.SetImagem(imagem[27].caminho);	m_b5.SetWindowText(imagem[27].nome);
		}

	m_b6.SetImagem(imagem[28].caminho);		m_b6.SetWindowText(imagem[28].nome);
	
	if(config.autoclique==false){
		m_b7.SetImagem(imagem[30].caminho); m_b7.SetWindowText(imagem[30].nome);
		}
	else{
		m_b7.SetImagem(imagem[29].caminho); m_b7.SetWindowText(imagem[29].nome);
		}
	if(config.varredura==false){
		m_b8.SetImagem(imagem[32].caminho); m_b8.SetWindowText(imagem[32].nome);
		}
	else{
		m_b8.SetImagem(imagem[31].caminho); m_b8.SetWindowText(imagem[31].nome);
		}
	if(config.masculino==true){
		m_b9.SetImagem(imagem[34].caminho); m_b9.SetWindowText(imagem[34].nome);
		}
	else{
		m_b9.SetImagem(imagem[33].caminho); m_b9.SetWindowText(imagem[33].nome);
		}
	if(config.som==false){
		m_b10.SetImagem(imagem[36].caminho); m_b10.SetWindowText(imagem[36].nome);
		}
	else{
		m_b10.SetImagem(imagem[35].caminho); m_b10.SetWindowText(imagem[35].nome);
		}
	m_b11.SetImagem(imagem[37].caminho);		m_b11.SetWindowText(imagem[37].nome);
	m_b12.SetImagem(imagem[38].caminho);		m_b12.SetWindowText(imagem[38].nome);
	m_b13.SetImagem(imagem[39].caminho);		m_b13.SetWindowText(imagem[39].nome);
//MessageBox(imagem[32].caminho);
	UpdateData(FALSE);

}

void CPranchaVirtualDlg::InterPerfil()
{
	//***********************************
	// Interface do Perfil do Usurio	*
	//***********************************

// Limpa os botes da janela
	Limpar();

	m_bit1.SetFocus();	
	m_grupoativo=8;
	config.interfac="perfil";

	UpdateData();

// Oculta os botes vazios
	Ocultar();
	int pag=0;

// Verfica a pgina 
	for(int i=2;i<=m_pagina;i++){
		pag+=16;
		}
		
// Adiciona as imagens e o texto da interface perfil
	m_b1.SetImagem(imagem[2].caminho);	m_b1.SetWindowText(imagem[2].nome);
	m_b2.SetImagem(usuario[pag+1].caminho);	m_b2.SetWindowText(usuario[pag+1].nome);
	m_b3.SetImagem(usuario[pag+2].caminho);	m_b3.SetWindowText(usuario[pag+2].nome);
	m_b4.SetImagem(usuario[pag+3].caminho);	m_b4.SetWindowText(usuario[pag+3].nome);
	m_b5.SetImagem(usuario[pag+4].caminho);	m_b5.SetWindowText(usuario[pag+4].nome);
	m_b6.SetImagem(usuario[pag+5].caminho);	m_b6.SetWindowText(usuario[pag+5].nome);
	m_b7.SetImagem(usuario[pag+6].caminho);	m_b7.SetWindowText(usuario[pag+6].nome);
	m_b8.SetImagem(usuario[pag+7].caminho);	m_b8.SetWindowText(usuario[pag+7].nome);
	m_b9.SetImagem(usuario[pag+8].caminho);	m_b9.SetWindowText(usuario[pag+8].nome);
	m_b10.SetImagem(usuario[pag+9].caminho);	m_b10.SetWindowText(usuario[pag+9].nome);
	m_b11.SetImagem(usuario[pag+10].caminho);	m_b11.SetWindowText(usuario[pag+10].nome);
	m_b12.SetImagem(usuario[pag+11].caminho);	m_b12.SetWindowText(usuario[pag+11].nome);
	m_b13.SetImagem(usuario[pag+12].caminho);	m_b13.SetWindowText(usuario[pag+12].nome);
	m_b14.SetImagem(usuario[pag+13].caminho);	m_b14.SetWindowText(usuario[pag+13].nome);
	m_b15.SetImagem(usuario[pag+14].caminho);	m_b15.SetWindowText(usuario[pag+14].nome);
	m_b16.SetImagem(usuario[pag+15].caminho);	m_b16.SetWindowText(usuario[pag+15].nome);
	m_b17.SetImagem(usuario[pag+16].caminho);	m_b17.SetWindowText(usuario[pag+16].nome);
// Ultimo boto
	if(usuario[pag+18].caminho.GetLength()==0 && usuario[pag+18].caminho.GetLength()>0){
		m_b18.SetImagem(usuario[pag+17].caminho);	m_b18.SetWindowText(usuario[pag+17].nome);
		}
	else if(usuario[pag+18].caminho.GetLength()>0){
		m_b18.SetImagem(imagem[53].caminho);	m_b18.SetWindowText(imagem[53].nome);
		}
	else {
		m_b18.SetImagem("");	m_b18.SetWindowText("");
		}
	UpdateData(FALSE);

}

void CPranchaVirtualDlg::InterPrincipal()
{

	//*******************************
	//	Interface das Principal		*
	//*******************************

// Limpa os botes da janela
	Limpar();

	m_bit1.SetFocus();
	m_pagina=1;
	m_grupoativo=0;
	
	config.interfac="principal";
	UpdateData();

// Oculta os botes vazios
	Ocultar();
 
// Adiciona as imagens e o texto da interface principal
	m_b1.SetImagem(imagem[1].caminho);	m_b1.SetWindowText(imagem[1].nome);
	m_b2.SetImagem(imagem[2].caminho);	m_b2.SetWindowText(imagem[2].nome);
	m_b3.SetImagem(imagem[3].caminho);	m_b3.SetWindowText(imagem[3].nome);
	m_b4.SetImagem(imagem[4].caminho);	m_b4.SetWindowText(imagem[4].nome);
	m_b5.SetImagem(imagem[5].caminho);	m_b5.SetWindowText(imagem[5].nome);
	m_b6.SetImagem(imagem[6].caminho);	m_b6.SetWindowText(imagem[6].nome);
 
	m_b7.SetImagem(imagem[7].caminho);	m_b7.SetWindowText(imagem[7].nome);
	m_b8.SetImagem(imagem[8].caminho);	m_b8.SetWindowText(imagem[8].nome);
	m_b9.SetImagem(imagem[9].caminho);	m_b9.SetWindowText(imagem[9].nome);
	m_b10.SetImagem(imagem[10].caminho);	m_b10.SetWindowText(imagem[10].nome);
	m_b11.SetImagem(imagem[11].caminho);	m_b11.SetWindowText(imagem[11].nome);
	m_b12.SetImagem(imagem[12].caminho);	m_b12.SetWindowText(imagem[12].nome);

	m_b13.SetImagem(imagem[13].caminho); m_b13.SetWindowText(imagem[13].nome);
	m_b14.SetImagem(imagem[14].caminho);	m_b14.SetWindowText(imagem[14].nome);
	m_b15.SetImagem(imagem[15].caminho);	m_b15.SetWindowText(imagem[15].nome);
	m_b16.SetImagem(imagem[16].caminho);	m_b16.SetWindowText(imagem[16].nome);
	m_b17.SetImagem(imagem[17].caminho);	m_b17.SetWindowText(imagem[17].nome);
	m_b18.SetImagem(imagem[18].caminho);	m_b18.SetWindowText(imagem[18].nome);
	UpdateData(FALSE);

}
void CPranchaVirtualDlg::Limpar()
{
	//*******************************
	//	Apaga o arquivo dos botes	*
	//*******************************

	m_b1.m_arquivo=="";	m_b2.m_arquivo=="";	m_b3.m_arquivo=="";
	m_b4.m_arquivo=="";	m_b5.m_arquivo=="";	m_b6.m_arquivo=="";
	m_b7.m_arquivo=="";	m_b8.m_arquivo=="";	m_b9.m_arquivo=="";
	m_b10.m_arquivo=="";m_b11.m_arquivo=="";m_b12.m_arquivo=="";
	m_b13.m_arquivo=="";m_b14.m_arquivo=="";m_b15.m_arquivo=="";
	m_b16.m_arquivo=="";m_b17.m_arquivo=="";m_b18.m_arquivo=="";

}
 
void CPranchaVirtualDlg::Menu(CString nome, int posicao) 
{
	//***************************************
	// Funo aps o menu ser selecionado	*
	//***************************************

/*
	Essa funo  declarada nessa classe pois ela  chamada pelo boto
	e pela janela do aplicativo
	
	Onde:
		NOME=Texto do boto
		POSIO= funo
			1 inserir
			2 editar
			3 apagar
*/

	CString nome2,caminho;
	int i=0;
	int pos=0;
	int contador=0;

// Acha a posio do nome na matriz
	int maior=0;
	if(m_grupoativo>0 && m_grupoativo<7){
		do{

			if(nome==grupo[m_grupoativo][i].nome){
				nome2=grupo[m_grupoativo][i].nome;
				caminho=grupo[m_grupoativo][i].caminho;
				contador=grupo[m_grupoativo][i].contador;
				pos=i;
				}
			if(grupo[m_grupoativo][i].codigo>grupo[m_grupoativo][i+1].codigo && maior<grupo[m_grupoativo][i].codigo && grupo[m_grupoativo][i].codigo>=0){
				maior=grupo[m_grupoativo][i].codigo;
				}
			else if(maior<grupo[m_grupoativo][i].codigo && grupo[m_grupoativo][i+1].codigo>=0){
				maior=grupo[m_grupoativo][i+1].codigo;
				}
			i++;
			}while(grupo[m_grupoativo][i].nome.GetLength()>0);
		}
	else{
		do{
			if(nome==imagem[i].nome){
				nome2=imagem[i].nome;
				caminho=imagem[i].caminho;
				pos=i;
				}
				i++;
			}while(i<=54);
		}
// BOTES DO SISTEMA

// Edio
	if(m_grupoativo==0 || m_grupoativo==7 || 
		((m_grupoativo>0 && m_grupoativo<7) ||(m_grupoativo==8))&&( imagem[2].nome==nome || imagem[53].nome==nome)){
// Abre a janela Perfil
		CPerfilDlg a; 
		a.m_b1.SetImagem(caminho);
		a.m_vedit=nome2;
		a.DoModal();

// Se no for repetido, atualiza os valores na posio do boto
		if(a.m_confirmar==true && a.m_repetido==false && a.m_vedit.GetLength()>0 && a.m_b1.m_arquivo.GetLength()>0){
			imagem[pos].nome=a.m_vedit;
			imagem[pos].caminho=a.m_b1.m_arquivo;
			}
// Aualiza a janela
		if(m_grupoativo==0)InterPrincipal();
		if(m_grupoativo>0 && m_grupoativo<7)InterGrupo();
		if(m_grupoativo==7)InterOpcao();
		if(m_grupoativo==8)InterPerfil();
		}

// BOTES SMBOLOS

	else if(m_grupoativo>0 && m_grupoativo<7){
// Insere smbolo Novo na Interface Grupo
		if(posicao==1){	
// Abre a janela Perfil
			CPerfilDlg a; 
			a.DoModal();
// Se no for repetido, atualiza os valores
			if(a.m_confirmar==true && a.m_repetido==false && a.m_vedit.GetLength()>0 && a.m_b1.m_arquivo.GetLength()>0){
//				MessageBox("a");
// Adiciona a imagem no grupo com seus valores (codigo, nome, caminho, histrico, contador)	
				if(nome=="*"){
					pos=i;
					}
				else{
					for(int j=i;j>pos;j--){
						grupo[m_grupoativo][j].codigo=grupo[m_grupoativo][j-1].codigo;
						grupo[m_grupoativo][j].nome=grupo[m_grupoativo][j-1].nome;
						grupo[m_grupoativo][j].caminho=grupo[m_grupoativo][j-1].caminho;
						grupo[m_grupoativo][j].historico=grupo[m_grupoativo][j-1].historico;
						grupo[m_grupoativo][j].contador=grupo[m_grupoativo][j-1].contador;

						}
					}
				maior++;

				grupo[m_grupoativo][pos].codigo=maior;
				grupo[m_grupoativo][pos].nome=a.m_vedit;
				grupo[m_grupoativo][pos].caminho=a.m_b1.m_arquivo;
				grupo[m_grupoativo][pos].historico="00 00 00 00 00 00";
				grupo[m_grupoativo][pos].contador=contador;
				}
			InterGrupo();		
			}
// Editar na Interface Grupo
		if(posicao==2){		
// Abre a janela Perfil
			CPerfilDlg a; 
			a.m_b1.SetImagem(caminho);
			a.m_vedit=nome2;
			a.DoModal();
// Se no for repetido, atualiza os valores
			if(a.m_confirmar==true && a.m_repetido==false && a.m_vedit.GetLength()>0 && a.m_b1.m_arquivo.GetLength()>0){
				grupo[m_grupoativo][pos].nome=a.m_vedit;
				grupo[m_grupoativo][pos].caminho=a.m_b1.m_arquivo;
				}
			}
// Apagar na Interface Grupo
		if(posicao==3){	
// Retira a imagem do grupo com seus valores (codigo, nome, caminho, histrico, contador)				
			for(int j=pos;j<=i;j++){
				grupo[m_grupoativo][j].caminho	 = grupo[m_grupoativo][j+1].caminho;
				grupo[m_grupoativo][j].codigo	 = grupo[m_grupoativo][j+1].codigo;
				grupo[m_grupoativo][j].contador	 = grupo[m_grupoativo][j+1].contador;
				grupo[m_grupoativo][j].historico = grupo[m_grupoativo][j+1].historico;
				grupo[m_grupoativo][j].nome		 = grupo[m_grupoativo][j+1].nome;
				
				}
			}
// Atualiza a interface
		InterGrupo();
		}

// BOTES USURIOS

	else if(m_grupoativo==8){
		i=0;
// acha aposicao do usuario
		do{
			if(nome==usuario[i].nome){
				nome2=usuario[i].nome;
				caminho=usuario[i].caminho;
				pos=i;
				}
			i++;
			}while(usuario[i].nome.GetLength()>0);
//		MessageBox("");
// Adiciona usurio
		if(posicao==1){
// Abre a janela Perfil
			CPerfilDlg a; a.DoModal();
// Verifica se o nome  vlido
			if((a.m_vedit.ReverseFind('\\')>=0) ||
				(a.m_vedit.ReverseFind('/')>=0) ||
				(a.m_vedit.ReverseFind(':')>=0) ||
				(a.m_vedit.ReverseFind('*')>=0) ||
				(a.m_vedit.ReverseFind('<')>=0) ||
				(a.m_vedit.ReverseFind('>')>=0) ||
				(a.m_vedit.ReverseFind('"')>=0) ||
				(a.m_vedit.ReverseFind('|')>=0) ||
				(a.m_vedit.ReverseFind('?')>=0)){
				MessageBox("O nome no pode conter '\\,/,:,*,<,>,\",|,?'.","ERRO",MB_ICONERROR);
				return;
				}
// Se no for repetido, cria o usurio e replica os dados do usurio padro
			if(a.m_confirmar==true && a.m_repetido==false && a.m_vedit.GetLength()>0 && a.m_b1.m_arquivo.GetLength()>0){

				usuario[i].nome=a.m_vedit;
				usuario[i].caminho=a.m_b1.m_arquivo;
				CreateDirectory(m_diretorio+"//"+usuario[i].nome,NULL);
				CopyFile(m_diretorio+"//Padro//config.ini",m_diretorio+"//"+usuario[i].nome+"//config.ini",false);
				CopyFile(m_diretorio+"//Padro//Interface.cfg",m_diretorio+"//"+usuario[i].nome+"//interface.cfg",false);
				CopyFile(m_diretorio+"//Padro//grupo1.cfg",m_diretorio+"//"+usuario[i].nome+"//grupo1.cfg",false);
				CopyFile(m_diretorio+"//Padro//grupo2.cfg",m_diretorio+"//"+usuario[i].nome+"//grupo2.cfg",false);
				CopyFile(m_diretorio+"//Padro//grupo3.cfg",m_diretorio+"//"+usuario[i].nome+"//grupo3.cfg",false);
				CopyFile(m_diretorio+"//Padro//grupo4.cfg",m_diretorio+"//"+usuario[i].nome+"//grupo4.cfg",false);
				CopyFile(m_diretorio+"//Padro//grupo5.cfg",m_diretorio+"//"+usuario[i].nome+"//grupo5.cfg",false);
				CopyFile(m_diretorio+"//Padro//grupo6.cfg",m_diretorio+"//"+usuario[i].nome+"//grupo6.cfg",false);
				WritePrivateProfileString("Configuraes da Prancha Virtual","perfil",usuario[i].caminho,m_diretorio+"//"+usuario[i].nome+"//config.ini");
			
				CString nomes;
				for(int k=1;k<=i;k++){
					nomes+=usuario[k].nome;
					nomes+="*";
					}
				nomes.TrimRight();
				WritePrivateProfileString("Usurios da Prancha Virtual","usurios",nomes,m_diretorio+"//config.ini");
				}
			}
// Edita o usurio
		if(posicao==2){	
// Abre a janela Perfil
			CPerfilDlg a;
			a.m_b1.SetImagem(caminho);
			a.m_vedit=nome2;
			a.DoModal();
// Verifica se o nome  vlido
			if((a.m_vedit.ReverseFind('\\')>=0) ||
				(a.m_vedit.ReverseFind('/')>=0) ||
				(a.m_vedit.ReverseFind(':')>=0) ||
				(a.m_vedit.ReverseFind('*')>=0) ||
				(a.m_vedit.ReverseFind('<')>=0) ||
				(a.m_vedit.ReverseFind('>')>=0) ||
				(a.m_vedit.ReverseFind('"')>=0) ||
				(a.m_vedit.ReverseFind('|')>=0) ||
				(a.m_vedit.ReverseFind('?')>=0)){
				MessageBox("O nome no pode conter '\\,/,:,*,<,>,\",|,?'.","ERRO",MB_ICONERROR);
				return;
				}
// Se no for repetido, altera o usurio
			if(a.m_confirmar==true && a.m_vedit.GetLength()>0 && a.m_b1.m_arquivo.GetLength()>0){
			
				usuario[pos].nome=a.m_vedit;
				usuario[pos].caminho=a.m_b1.m_arquivo;
				rename(m_diretorio+"//"+nome,m_diretorio+"//"+usuario[pos].nome);
				WritePrivateProfileString("Configuraes da Prancha Virtual","perfil",usuario[pos].caminho,m_diretorio+"//"+usuario[pos].nome+"//config.ini");
//				MessageBox((CString)a.m_confirmar);
				}
			}
// Apaga o usurio
		if(posicao==3){	
			for(int j=pos;j<=i;j++){
				usuario[j].caminho	=usuario[j+1].caminho;
				usuario[j].nome		=usuario[j+1].nome;
				}
// Apaga os arquivos referentes aos usurios			
			CFileFind procurar;
			procurar.FindFile(m_diretorio+nome+"\\*.*");
			bool cheio=procurar.FindNextFile();
			while(cheio==1){
				cheio=procurar.FindNextFile();
				DeleteFile(procurar.GetFilePath());
				}
			procurar.Close();
			SetCurrentDirectory("c:\\");
			RemoveDirectory(m_diretorio+nome);
// Aplica as configuraes do usurio
			UsuConf(usuario[1].nome);
			Invalidate();
	
			}
// Atualiza a interface
		InterPerfil();
		}
// Salva as configuraes dio usurio atual		
	IniFechar();
}

void CPranchaVirtualDlg::MenuInserir() 
{
	//***********************************************
	// Chamada do Menu pelo boto direito do Mouse	*
	//***********************************************

// Chama a funo menu com o parametro 1;
	Menu("*",1);
}
void CPranchaVirtualDlg::Ocultar()
{
	
	//***********************************
	//	esconde os botes vazios		*
	//***********************************

	
// Pgina dos botes
	if(m_grupoativo==0){
		m_b1.ShowWindow(true);	m_b2.ShowWindow(true);	m_b3.ShowWindow(true);	m_b4.ShowWindow(true);
		m_b5.ShowWindow(true);	m_b6.ShowWindow(true);	m_b7.ShowWindow(true);	m_b8.ShowWindow(true);
		m_b9.ShowWindow(true);	m_b10.ShowWindow(true);	m_b11.ShowWindow(true);	m_b12.ShowWindow(true);
		if(imagem[13].caminho.GetLength()==0)m_b13.ShowWindow(false);else m_b13.ShowWindow(true);
		if(imagem[14].caminho.GetLength()==0)m_b14.ShowWindow(false);else m_b14.ShowWindow(true);
		if(imagem[15].caminho.GetLength()==0)m_b15.ShowWindow(false);else m_b15.ShowWindow(true);
		if(imagem[16].caminho.GetLength()==0)m_b16.ShowWindow(false);else m_b16.ShowWindow(true);
		if(imagem[17].caminho.GetLength()==0)m_b17.ShowWindow(false);else m_b17.ShowWindow(true);
		if(imagem[18].caminho.GetLength()==0)m_b18.ShowWindow(false);else m_b18.ShowWindow(true);
		}
// Tela de opes
	if(m_grupoativo==7){
		m_b1.ShowWindow(true);	m_b2.ShowWindow(true);	m_b3.ShowWindow(true);	m_b4.ShowWindow(true);
		m_b5.ShowWindow(true);	m_b6.ShowWindow(true);	
		
		if (config.autoclique==1) m_b8.ShowWindow(false);	
		else m_b8.ShowWindow(true);	
		
		if (config.varredura==1) m_b7.ShowWindow(false);	
		else m_b7.ShowWindow(true);	
		
		m_b11.ShowWindow(true);
		
		m_b12.ShowWindow(true);m_b13.ShowWindow(true);m_b14.ShowWindow(false);
		m_b15.ShowWindow(false);m_b16.ShowWindow(false);
		m_b17.ShowWindow(false);m_b18.ShowWindow(false);
		}
// Tela de Perfil
	if(m_grupoativo==8){
		int pag=0;
		for(int i=2;i<=m_pagina;i++){
			pag+=16;
			}
		m_b1.ShowWindow(true);
		if(usuario[pag+1].caminho=="")m_b2.ShowWindow(false);else m_b2.ShowWindow(true);
		if(usuario[pag+2].caminho=="")m_b3.ShowWindow(false);else m_b3.ShowWindow(true);
		if(usuario[pag+3].caminho=="")m_b4.ShowWindow(false);else m_b4.ShowWindow(true);
		if(usuario[pag+4].caminho=="")m_b5.ShowWindow(false);else m_b5.ShowWindow(true);
		if(usuario[pag+5].caminho=="")m_b6.ShowWindow(false);else m_b6.ShowWindow(true);
		if(usuario[pag+6].caminho=="")m_b7.ShowWindow(false);else m_b7.ShowWindow(true);
		if(usuario[pag+7].caminho=="")m_b8.ShowWindow(false);else m_b8.ShowWindow(true);
		if(usuario[pag+8].caminho=="")m_b9.ShowWindow(false);else m_b9.ShowWindow(true);
		if(usuario[pag+9].caminho=="")m_b10.ShowWindow(false);else m_b10.ShowWindow(true);
		if(usuario[pag+10].caminho=="")m_b11.ShowWindow(false);else m_b11.ShowWindow(true);
		if(usuario[pag+11].caminho=="")m_b12.ShowWindow(false);else m_b12.ShowWindow(true);
		if(usuario[pag+12].caminho=="")m_b13.ShowWindow(false);else m_b13.ShowWindow(true);
		if(usuario[pag+13].caminho=="")m_b14.ShowWindow(false);else m_b14.ShowWindow(true);
		if(usuario[pag+14].caminho=="")m_b15.ShowWindow(false);else m_b15.ShowWindow(true);
		if(usuario[pag+15].caminho=="")m_b16.ShowWindow(false);else m_b16.ShowWindow(true);
		if(usuario[pag+16].caminho=="")m_b17.ShowWindow(false);else m_b17.ShowWindow(true);
		if(usuario[pag+18].caminho=="" && usuario[pag+17].caminho.GetLength()>0){
			m_b18.ShowWindow(true);
			}
		else if(usuario[pag+18].caminho.GetLength()>0){
			m_b18.ShowWindow(true);
			}
		else {
			m_b18.ShowWindow(false);
			}
		}
// Tela de Grupos
	if(m_grupoativo>0 && m_grupoativo<7){
		int pag=0;
 
// Se a jagina for maior que 1 no existe o boo voltar


		for(int i=2;i<=m_pagina;i++){
			pag+=15;
			}
		m_b1.ShowWindow(true);
		if(grupo[m_grupoativo][pag+1].caminho=="")m_b2.ShowWindow(false);else m_b2.ShowWindow(true);
		if(grupo[m_grupoativo][pag+2].caminho=="")m_b3.ShowWindow(false);else m_b3.ShowWindow(true);
		if(grupo[m_grupoativo][pag+3].caminho=="")m_b4.ShowWindow(false);else m_b4.ShowWindow(true);
		if(grupo[m_grupoativo][pag+4].caminho=="")m_b5.ShowWindow(false);else m_b5.ShowWindow(true);
		if(grupo[m_grupoativo][pag+5].caminho=="")m_b6.ShowWindow(false);else m_b6.ShowWindow(true);
		if(grupo[m_grupoativo][pag+6].caminho=="")m_b7.ShowWindow(false);else m_b7.ShowWindow(true);
		if(grupo[m_grupoativo][pag+7].caminho=="")m_b8.ShowWindow(false);else m_b8.ShowWindow(true);
		if(grupo[m_grupoativo][pag+8].caminho=="")m_b9.ShowWindow(false);else m_b9.ShowWindow(true);
		if(grupo[m_grupoativo][pag+9].caminho=="")m_b10.ShowWindow(false);else m_b10.ShowWindow(true);
		if(grupo[m_grupoativo][pag+10].caminho=="")m_b11.ShowWindow(false);else m_b11.ShowWindow(true);
		if(grupo[m_grupoativo][pag+11].caminho=="")m_b12.ShowWindow(false);else m_b12.ShowWindow(true);
		if(grupo[m_grupoativo][pag+12].caminho=="")m_b13.ShowWindow(false);else m_b13.ShowWindow(true);
		if(grupo[m_grupoativo][pag+13].caminho=="")m_b14.ShowWindow(false);else m_b14.ShowWindow(true);
		if(grupo[m_grupoativo][pag+14].caminho=="")m_b15.ShowWindow(false);else m_b15.ShowWindow(true);
		if(grupo[m_grupoativo][pag+15].caminho=="")m_b16.ShowWindow(false);else m_b16.ShowWindow(true);
		if(grupo[m_grupoativo][pag+16].caminho=="")m_b17.ShowWindow(false);else m_b17.ShowWindow(true);
		if(grupo[m_grupoativo][pag+18].caminho=="" && grupo[m_grupoativo][pag+17].caminho.GetLength()>0){
			m_b18.ShowWindow(true);
			}
		else if(grupo[m_grupoativo][pag+18].caminho.GetLength()>0){
			m_b18.ShowWindow(true);
			}
		else {
			m_b18.ShowWindow(false);
			}
		}
		
}
void CPranchaVirtualDlg::OnButGrupo() 
{
	//***********************************************
	//	Ao clicar sobre o boto da interface gupo	*
	//***********************************************

	int pos=1;

// Boto principal
	if(m_b1.m_cima==1 ){	
		InterPrincipal();
		}
// Volta a pgina
	if(m_b2.m_cima==1 && m_pagina>1){	
		m_pagina--;
		InterGrupo();
		}
// Avana a pgina
	else if(m_b18.m_cima==1 && m_b18.m_arquivo==imagem[53].caminho){

		m_pagina++;
		InterGrupo();
		}
	else {
		int i=1;
		while(m_pagina!=i){
			if(m_pagina>2)pos+=15;
			if(m_pagina==2)pos+=15;
			i++;
			}
		
// Boto voltar
		if(m_b2.m_cima==1 && m_pagina==1){	
			pos;
			}
// Ajusta a posio de cada Smbolo no vetor
		if(m_b3.m_cima==1 && m_b3.m_aberto==true)pos+=1;
		else if(m_b4.m_cima==1 && m_b4.m_aberto==true)pos+=2;
		else if(m_b5.m_cima==1 && m_b5.m_aberto==true)pos+=3;
		else if(m_b6.m_cima==1 && m_b6.m_aberto==true)pos+=4;
		else if(m_b7.m_cima==1 && m_b7.m_aberto==true)pos+=5;
		else if(m_b8.m_cima==1 && m_b8.m_aberto==true)pos+=6;
		else if(m_b9.m_cima==1 && m_b9.m_aberto==true)pos+=7;
		else if(m_b10.m_cima==1 && m_b10.m_aberto==true)pos+=8;
		else if(m_b11.m_cima==1 && m_b11.m_aberto==true)pos+=9;
		else if(m_b12.m_cima==1 && m_b12.m_aberto==true)pos+=10;
		else if(m_b13.m_cima==1 && m_b13.m_aberto==true)pos+=11;
		else if(m_b14.m_cima==1 && m_b14.m_aberto==true)pos+=12;
		else if(m_b15.m_cima==1 && m_b15.m_aberto==true)pos+=13;
		else if(m_b16.m_cima==1 && m_b16.m_aberto==true)pos+=14;
		else if(m_b17.m_cima==1 && m_b17.m_aberto==true)pos+=15;
		else if(m_b18.m_cima==1 && m_b18.m_aberto==true)pos+=16;
	
		grupo[m_grupoativo][pos].contador++;

// Fala o smbolo
	if (config.som==1){
		if(	SintetizadorAbrir(grupo[m_grupoativo][pos].nome)==false){
			MessageBox("No foi possvel iniciar o sintetizador.","ERRO",MB_ICONERROR);
			}
		}
			
// Adiciona o smbolo na frase
		if(grupo[m_grupoativo][pos].caminho.GetLength()>0){
			if(m_posicao!=6)m_posicao++;
			if(m_posicao==1){
				m_bit1.SetImagem(grupo[m_grupoativo][pos].caminho); 
				m_bit1.SetWindowText(grupo[m_grupoativo][pos].nome);
				m_bit1.Invalidate();
				}
			if(m_posicao==2){
				m_bit2.SetImagem(grupo[m_grupoativo][pos].caminho); 
				m_bit2.SetWindowText(grupo[m_grupoativo][pos].nome);
				m_bit2.Invalidate();
				}
			if(m_posicao==3){
				m_bit3.SetImagem(grupo[m_grupoativo][pos].caminho); 
				m_bit3.SetWindowText(grupo[m_grupoativo][pos].nome);
				m_bit3.Invalidate();
				}
			if(m_posicao==4){
				m_bit4.SetImagem(grupo[m_grupoativo][pos].caminho); 
				m_bit4.SetWindowText(grupo[m_grupoativo][pos].nome);
				m_bit4.Invalidate();
				}
			if(m_posicao==5){
				m_bit5.SetImagem(grupo[m_grupoativo][pos].caminho); 
				m_bit5.SetWindowText(grupo[m_grupoativo][pos].nome);
				m_bit5.Invalidate();
				}
			if(m_posicao==6 && m_bit6.m_arquivo==""){
				m_bit6.SetImagem(grupo[m_grupoativo][pos].caminho); 
				m_bit6.SetWindowText(grupo[m_grupoativo][pos].nome);
				m_bit6.Invalidate();
				}
			if(m_posicao==6 && m_bit6.m_arquivo!=""){
//				InterPrincipal();
//				return;
				}

			int tras=0,fim=0;

// Reposiciona o smbolo ordenando o acesso
			if( pos!=1){
				do{
					fim++;
					if(grupo[m_grupoativo][fim].contador>grupo[m_grupoativo][pos].contador)
						tras=fim;
					}while(grupo[m_grupoativo][fim].nome.GetLength()>0);
				tras++;
				CString f="";
				int tcod=grupo[m_grupoativo][pos].codigo;
				CString tnome=grupo[m_grupoativo][pos].nome;
				CString thist=grupo[m_grupoativo][pos].historico;
				CString tcami=grupo[m_grupoativo][pos].caminho;
				int tcont=grupo[m_grupoativo][pos].contador;
		
				for(int pp=pos;pp>tras;pp--){
		
					grupo[m_grupoativo][pp].codigo=grupo[m_grupoativo][pp-1].codigo;
					grupo[m_grupoativo][pp].nome=grupo[m_grupoativo][pp-1].nome;
					grupo[m_grupoativo][pp].historico=grupo[m_grupoativo][pp-1].historico;
					grupo[m_grupoativo][pp].caminho=grupo[m_grupoativo][pp-1].caminho;
					grupo[m_grupoativo][pp].contador=grupo[m_grupoativo][pp-1].contador;
					}
				grupo[m_grupoativo][tras].codigo=tcod;
				grupo[m_grupoativo][tras].nome=tnome;
				grupo[m_grupoativo][tras].historico=thist;
				grupo[m_grupoativo][tras].caminho=tcami;
				grupo[m_grupoativo][tras].contador=tcont;
				}
			}			
// Faz a predio
		Predicao(m_posicao);

// Volta a interface principal
		InterPrincipal();
	}

}
void CPranchaVirtualDlg::OnButOpcao() 
{
	//*******************************************
	//	Ao clicar sobre o boto na janla opo	*
	//*******************************************

// Boto voltar
	if(m_b1.m_cima==1){	InterPrincipal();
			}
// Boto cor
		else if(m_b3.m_cima==1){	
			if(config.varredura==1){	
				KillTimer(1);
				MessageBox("Desligue a varredura para ter acesso ao painel de cores","ATENO",MB_ICONEXCLAMATION );
				m_bit1.SetFocus();
				SetTimer(1,config.atraso*1000,0);
				}
			else{
// Abre a janela cor
				CColorDialog a; 
				if ( a.DoModal() == IDOK){
					CString a1,a2,a3,a4,a5,a6;
					a1=m_bit1.m_arquivo;	a2=m_bit2.m_arquivo;	a3=m_bit3.m_arquivo;
					a4=m_bit4.m_arquivo;	a5=m_bit5.m_arquivo;	a6=m_bit6.m_arquivo;
					m_bit1.SetImagem("");	m_bit2.SetImagem("");	m_bit3.SetImagem("");
					m_bit4.SetImagem("");	m_bit5.SetImagem("");	m_bit6.SetImagem("");
					config.cor=a.GetColor();
					m_bit1.SetImagem(a1);	m_bit2.SetImagem(a2);	m_bit3.SetImagem(a3);
					m_bit4.SetImagem(a4);	m_bit5.SetImagem(a5);	m_bit6.SetImagem(a6);
					Invalidate();
					}
				}
			}
// Boto papel de parede
		else if(m_b4.m_cima==1){
			if(config.varredura==1){	
				KillTimer(1);
				MessageBox("Desligue a varredura para ter acesso ao painel de papel de parede","ATENO",MB_ICONEXCLAMATION );
				m_bit1.SetFocus();
				SetTimer(1,config.atraso*1000,0);
				}
			else{
// Abre a janela de arquivo
				CFileDialog fileDlg(1, NULL, NULL, OFN_ALLOWMULTISELECT | OFN_HIDEREADONLY,"Imagens (*.bmp, *.gif, *.jpeg)|*.bmp;*.gif;*.jpg||",this);
				CString temp=m_desktop;
				temp+="\\Imagens da Prancha";
				fileDlg.m_ofn.lpstrInitialDir=temp;

				if ( fileDlg.DoModal() == IDOK){
					CString a1,a2,a3,a4,a5,a6;
					a1=m_bit1.m_arquivo;	a2=m_bit2.m_arquivo;	a3=m_bit3.m_arquivo;
					a4=m_bit4.m_arquivo;	a5=m_bit5.m_arquivo;	a6=m_bit6.m_arquivo;
					m_bit1.SetImagem("");	m_bit2.SetImagem("");	m_bit3.SetImagem("");
					m_bit4.SetImagem("");	m_bit5.SetImagem("");	m_bit6.SetImagem("");
					config.fundo=fileDlg.GetPathName();
					m_bit1.SetImagem(a1);	m_bit2.SetImagem(a2);	m_bit3.SetImagem(a3);
					m_bit4.SetImagem(a4);	m_bit5.SetImagem(a5);	m_bit6.SetImagem(a6);
					Invalidate();
					}
				}
			}
// Boto do tipo de papel
		else if(m_b5.m_cima==1){
			if(config.tipo=="Centro"){
				config.tipo="LLado";
				}
			else 
				if(config.tipo=="LLado"){
				config.tipo="Estender";
				}
			else 
				if(config.tipo=="Estender"){
				config.tipo="Centro";
				}
			InterOpcao();
			Invalidate();
			}
// Boto limpa o papel-de-parede
		else if(m_b6.m_cima==1){
			config.fundo="";
			config.cor=0x0808080;
			Invalidate();
			}
// Boto autoclique
		 else if(m_b7.m_cima==1){
			
			 if (config.autoclique==1){
				config.autoclique=false;
				KillTimer(1);
				m_b8.ShowWindow(FALSE);
				}
			else {
				COpcaoDlg a;
				a.DoModal();
				if(a.m_confirmar==true)config.autoclique=1;
				
				}
			InterOpcao();

			}
// Boto varredura
		else if(m_b8.m_cima==1){
			if (config.varredura==1){
				config.varredura=false;
				KillTimer(1);
				m_b7.SetCor(GetSysColor(COLOR_BTNFACE));
				}
			else {
				COpcaoDlg a;
				a.DoModal();
				if(a.m_confirmar==true){
					SetTimer(1,config.atraso*1000,0);
					config.varredura=1;
					}
				m_bit1.SetFocus();	
				}
			InterOpcao();
			}
// Boto homem
		else if(m_b9.m_cima==1){
			if (config.masculino==1){
				config.masculino=0;
				}
			else{
				config.masculino=1;
				}
			InterOpcao();
			}
// Boto som 
		else if(m_b10.m_cima==1){
			if (config.som==1){
				config.som=0;
				}
			else{
				config.som=1;
				}
			InterOpcao();
			}

			
// Boto legenda
		else if(m_b2.m_cima==1){
			OnLegenda();
			InterOpcao();
			Invalidate();
			}
		else if(m_b11.m_cima==1){

			if(MessageBox("Deseja limpar o banco dem imagens?","",MB_YESNO |MB_ICONQUESTION)== IDYES){
// Apaga cada arquivo da pasta do usurio
				CFileFind procurar;
				procurar.FindFile(m_diretorio+usuario[1].nome+"\\*.*");
				bool cheio=procurar.FindNextFile();
				while(cheio==1){
					cheio=procurar.FindNextFile();
					CString nome=procurar.GetFileName();
//			MessageBox(nome);
					if(nome.Find("grupo",0)>=0){
						nome=procurar.GetFilePath();
						CFile arquivo2;
						if(	arquivo2.Open(nome,CFile::modeCreate | CFile::modeWrite))//Cria o arquivo
						arquivo2.SetLength(0);
						arquivo2.Write("",0);
						arquivo2.Close();
						UsuConf(usuario[1].nome);
						}
					}
				procurar.Close();
				}
			}
		else if(m_b12.m_cima==1){
			OnImprimir();
			}
		else if(m_b13.m_cima==1){
			WinExec("hh.exe "+m_diretorio+"AjudaPrancha.chm" ,SW_SHOW);
			}

	
}
void CPranchaVirtualDlg::OnButPerfil() 
{
	//***********************************************
	//	Ao clicar sobre o boto na janela perfil	*
	//***********************************************

	int pos=0;
// Boto voltar
	if(m_b1.m_cima==1 && m_pagina==1){	
		InterPrincipal();
		}
	else if(m_b1.m_cima==1 && m_pagina>1){	
		m_pagina--;
		InterPerfil();
		}
	else if(m_b18.m_cima==1 && m_b18.m_arquivo==imagem[53].caminho){
		m_pagina++;
		InterPerfil();
		}
	else {
// Limpa a frase
		m_bit1.m_arquivo="";
		m_bit2.m_arquivo="";
		m_bit3.m_arquivo="";
		m_bit4.m_arquivo="";
		m_bit5.m_arquivo="";
		m_bit6.m_arquivo="";
		m_area.Invalidate();
		m_posicao=0;
// Salva as configuraes
		IniFechar();
		int i=1;
// Verifica a pgina
		while(m_pagina!=i){
			pos+=16;
			i++;
			}
// Ajusta a posio emrelao a po boto
		if(m_b2.m_cima==1)pos+=1;
		if(m_b3.m_cima==1)pos+=2;
		if(m_b4.m_cima==1)pos+=3;
		if(m_b5.m_cima==1)pos+=4;
		if(m_b6.m_cima==1)pos+=5;
		if(m_b7.m_cima==1)pos+=6;
		if(m_b8.m_cima==1)pos+=7;
		if(m_b9.m_cima==1)pos+=8;
		if(m_b10.m_cima==1)pos+=9;
		if(m_b11.m_cima==1)pos+=10;
		if(m_b12.m_cima==1)pos+=11;
		if(m_b13.m_cima==1)pos+=12;
		if(m_b14.m_cima==1)pos+=13;
		if(m_b15.m_cima==1)pos+=14;
		if(m_b16.m_cima==1)pos+=15;
		if(m_b17.m_cima==1)pos+=16;
		if(m_b18.m_cima==1)pos+=17;
		
		CString temp1,temp2;
		if(pos>1){
			int pp=0;
			do{
				pp++;
//			MessageBox("s");
				}while(usuario[pp].nome.GetLength()!=0);
			temp1=usuario[pos].nome   ;
			temp2=usuario[pos].caminho;
// Reordena os usurios
			for(int z=pos;z!=0;z--){

				usuario[z].nome=usuario[z-1].nome;
				usuario[z].caminho=usuario[z-1].caminho;
				}
			usuario[1].nome   =temp1;
			usuario[1].caminho=temp2;

// Ativa as configuraes do usuario
			UsuConf(usuario[1].nome);
		
			CString usuarios;
			pos=1;

			do{
				usuarios+=usuario[pos].nome;
				usuarios+="*";
				pos++;
				}while(usuario[pos].nome.GetLength()>0);
			WritePrivateProfileString("Usurios da Prancha Virtual","usurios",usuarios,m_diretorio+"\\config.ini");
			}
		m_bit1.SetImagem("");m_bit2.SetImagem("");m_bit3.SetImagem("");
		m_bit4.SetImagem("");m_bit5.SetImagem("");m_bit6.SetImagem("");
		Invalidate();
		InterPrincipal();
	}
}
void CPranchaVirtualDlg::OnButPredicao(int pos) 
{
	//*******************************
	//	ao presioanar a predio	*
	//*******************************

// Adiciona o simbolo clicado a frase
		if(imagem[pos].caminho.GetLength()>0){
// Fala o smbolo

			if (config.som==1){
				if(SintetizadorAbrir(imagem[pos].nome)==false){
						MessageBox("No foi possvel iniciar o sintetizador .","ERRO",MB_ICONERROR);
						}
				}
			m_posicao++;
			if(m_posicao==1){
				m_bit1.SetImagem(imagem[pos].caminho); 
				m_bit1.SetWindowText(imagem[pos].nome);
				m_bit1.Invalidate();
				}
			if(m_posicao==2){
				m_bit2.SetImagem(imagem[pos].caminho); 
				m_bit2.SetWindowText(imagem[pos].nome);
				m_bit2.Invalidate();
				}
			if(m_posicao==3){
				m_bit3.SetImagem(imagem[pos].caminho); 
				m_bit3.SetWindowText(imagem[pos].nome);
				m_bit3.Invalidate();
				}
			if(m_posicao==4){
				m_bit4.SetImagem(imagem[pos].caminho); 
				m_bit4.SetWindowText(imagem[pos].nome);
				m_bit4.Invalidate();
				}
			if(m_posicao==5){
				m_bit5.SetImagem(imagem[pos].caminho); 
				m_bit5.SetWindowText(imagem[pos].nome);
				m_bit5.Invalidate();
				}
			if(m_posicao==6){
				m_bit6.SetImagem(imagem[pos].caminho); 
				m_bit6.SetWindowText(imagem[pos].nome);
				m_bit6.Invalidate();
				}
// Acha o smbolo no grupo e incrementa o contador
			for(int j=1;j<=6;j++){
				int i=1;
				do{
					if(imagem[pos].nome==grupo[j][i].nome){
						grupo[j][i].contador++;
						CString dor;
						dor.Format("%d",grupo[j][i].contador);
						if(grupo[j][i].contador>=grupo[j][i-1].contador && i!=1){
							int tcod=grupo[j][i].codigo;
							CString tnome=grupo[j][i].nome;
							CString thist=grupo[j][i].historico;
							CString tcami=grupo[j][i].caminho;
							int tcont=grupo[j][i].contador;
				
							grupo[j][i].codigo=grupo[j][i-1].codigo;
							grupo[j][i].nome=grupo[j][i-1].nome;
							grupo[j][i].historico=grupo[j][i-1].historico;
							grupo[j][i].caminho=grupo[j][i-1].caminho;
							grupo[j][i].contador=grupo[j][i-1].contador;

							grupo[j][i-1].codigo=tcod;
							grupo[j][i-1].nome=tnome;
							grupo[j][i-1].historico=thist;
							grupo[j][i-1].caminho=tcami;
							grupo[j][i-1].contador=tcont;
							}
						}
					i++;
					}while(grupo[j][i].nome.GetLength()>0);
				}
			}			
// Faz a predio
		Predicao(m_posicao);
// Atualiza a interface
		InterPrincipal();
	

}

void CPranchaVirtualDlg::OnButPrincipal() 
{
	//***********************************************
	//	Ao clicar sobre o boto na janela principal	*
	//***********************************************

// Boto limpar
	if(m_b1.m_cima==1){	
// Zera o caminho das imagens da frase.
		m_bit1.m_arquivo="";
		m_bit2.m_arquivo="";
		m_bit3.m_arquivo="";
		m_bit4.m_arquivo="";
		m_bit5.m_arquivo="";
		m_bit6.m_arquivo="";
// Atualiza a rea da frase
		m_area.Invalidate();
		m_posicao=0;
// Atualiza a interface
		InterPrincipal();
		}
// Boto voltar
	else if(m_b2.m_cima==1 && m_posicao>=1){	
// Limpa o ltimo smbolo da frase
		m_area.Invalidate();
		if(m_posicao==1) m_bit1.m_arquivo="";
		if(m_posicao==2) m_bit2.m_arquivo="";
		if(m_posicao==3) m_bit3.m_arquivo="";
		if(m_posicao==4) m_bit4.m_arquivo="";
		if(m_posicao==5) m_bit5.m_arquivo="";
		if(m_posicao==6) m_bit6.m_arquivo="";
// Atualiza o ltimo smbolo da frase
		if(m_posicao>1)m_bit1.Invalidate();
		if(m_posicao>2) m_bit2.Invalidate();
		if(m_posicao>3) m_bit3.Invalidate();
		if(m_posicao>4) m_bit4.Invalidate();
		if(m_posicao>5) m_bit5.Invalidate();
		if(m_posicao>6) m_bit6.Invalidate();
		m_posicao--;
// Faz a predio do autual ltimo smbolo
		Predicao(m_posicao+10);
// Atualiza a interface
		InterPrincipal();
		}
// Boto falar
	else if(m_b3.m_cima==1){	OnFalar(); 
		}
// Boto opo
	else if(m_b4.m_cima==1){	InterOpcao();	
		}
// Boto Perfil
	else if(m_b5.m_cima==1){	InterPerfil();	
		}
// Boto sair
	else if(m_b6.m_cima==1){
// Encerra o timer
		if(config.varredura==1)	KillTimer(1);

		if(MessageBox("Deseja sair da Prancha Livre de Comunicao?","",MB_YESNO |MB_ICONQUESTION)== IDYES){
// Fecha o sintetizador
			if(sintativo==true)	SintetizadorFechar();
 // Salva as configuracoes no arquivo .ini
			IniFechar();
// Retorna a resoluo da tela
			Resolucao(m_resx,m_resy);
// Encerra o aplicativo
			exit(0);	

			}
// Se no saiu, volta o timer
		if(config.varredura==1){
			m_bit1.SetFocus();
			SetTimer(1,config.atraso*1000,0);
			}
		}
// Boto grupos
	else if(m_b7.m_cima==1){	m_grupoativo=1;	InterGrupo();	//EXP SOCIAIS
		}
	else if(m_b8.m_cima==1){	m_grupoativo=2;	InterGrupo();	//PESSOAS
		}
	else if(m_b9.m_cima==1){	m_grupoativo=3;	InterGrupo();	//SUBSTANTIVOS
		}
	else if(m_b10.m_cima==1){	m_grupoativo=4;	InterGrupo();	//VERBOS
		}
	else if(m_b11.m_cima==1){	m_grupoativo=5;	InterGrupo();	//ADJETIVOS
		}
	else if(m_b12.m_cima==1){	m_grupoativo=6;	InterGrupo();	//MISCELANIA
		}
// Boto predio
	else if(m_b13.m_cima==1){	OnButPredicao(13);//PREDIO 1
		}
	else if(m_b14.m_cima==1){	OnButPredicao(14);//PREDIO 2
		}
	else if(m_b15.m_cima==1){	OnButPredicao(15);//PREDIO 3
		}
	else if(m_b16.m_cima==1){	OnButPredicao(16);//PREDIO 4
		}
	else if(m_b17.m_cima==1){	OnButPredicao(17);//PREDIO 5
		}
	else if(m_b18.m_cima==1){	OnButPredicao(18);//PREDIO 6
		}

}

void CPranchaVirtualDlg::OnButton() 
{
	//***************************************************************
	//	Boto de origem, envia a funo de acordo com a interface	*
	//***************************************************************

	// 	Concentra todos os cliques. Apartir da, encaminha a interface 
	
// Boto principal
	if(m_grupoativo==0)OnButPrincipal();

// Boto perfil
	else if(m_grupoativo==8)OnButPerfil();

// Boto opo
	else if(m_grupoativo==7)OnButOpcao();
		
// Boto grupo
	else if(m_grupoativo>0 && m_grupoativo<7)OnButGrupo();
}

void CPranchaVirtualDlg::OnDestroy() 
{
	//***********************
	// Encerra o aplicativo	*
	//***********************

	CDialog::OnDestroy();


// Retorna a resoluo da tela
	Resolucao(m_resx,m_resy);

// Fecha o sintetizador
	SintetizadorFechar();
 
}

BOOL CPranchaVirtualDlg::OnEraseBkgnd(CDC* pDC) 
{

	//*******************************
	// Desenha o fundo da janela	*
	//*******************************

	CDialog::OnEraseBkgnd(pDC);	

	CRect rect;

	CString dados;
	COLORREF cor=config.cor;
/*
	if(m_grupoativo==1)dados="0x08a008a";
	if(m_grupoativo==2)dados="0x0c1c1";
	if(m_grupoativo==3)dados="0x078f0";
	if(m_grupoativo==4)dados="0x07900";
	if(m_grupoativo==5)dados="0x0a00000";
	if(m_grupoativo==6)dados="0x0ffffff";
*/		
	
	if(dados.GetLength()>0)
			sscanf(dados, "%08X", &cor);
	
	CBrush backBrush=cor;
	CBrush* pOldBrush = pDC->SelectObject(&backBrush);

	pDC->GetClipBox(&rect);
	pDC->PatBlt(rect.left, rect.top, rect.Width(), rect.Height(), PATCOPY);
	pDC->SelectObject(pOldBrush);
	GetClientRect(&rect);

	CDC dc;
	dc.CreateCompatibleDC(pDC);

// Adiciona o Wallpaper
	if(config.fundo.GetLength()>0){

		CRect rect;
		
// Posiciona o papel-de-parede de acordo com o tipo selecionado		
		GetDesktopWindow()->GetWindowRect( &rect); 
	
	if(config.tipo == "LLado"){
		m_tipo = "LLado";
		}
	if(config.tipo == "Centro"){
		m_tipo = "Centro";
		}

	if(config.tipo == "Estender"){
		m_tipo = "Estender";
		rect.left=0;
		rect.top=0;
		rect.right=rect.Width();
		rect.bottom=rect.Height();
		}
	Imagem(pDC,config.fundo, rect);
	m_tipo="";
	}
	return 1;
}

void CPranchaVirtualDlg::OnLegenda()
{
	//***********************************
	// Retira ou no a legenda da frase	*
	//***********************************

	UpdateData();

// No  utilizado o menu de legenda no aplicativo
// Sinaliza no menu a legenda em cheked ou unchecked 
	HMENU hMenu;
	hMenu = ::GetMenu(this->GetSafeHwnd());
	HMENU hSubMenu;
	hSubMenu = ::GetSubMenu(hMenu, 0);

// Altera o valor da legenda
	if(config.legenda==1){
		config.legenda=false;
		CheckMenuItem(hMenu,ID_OPES_LEGENDA,MF_UNCHECKED );
		}
	else {
		config.legenda=1;
		CheckMenuItem(hMenu,ID_OPES_LEGENDA,MF_CHECKED );
		}

// Atualiza os botes
		m_b18.Invalidate();

	UpdateData(FALSE);
			
}

	


void CPranchaVirtualDlg::OnImprimir()
{	
	
	//****************************************
	//*	Evento de clique no boto imprimir	 *
	//****************************************
// Pega o texto da frase

	CString frase,temp;
	m_bit1.GetWindowText(temp);
	if(m_bit1.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit2.GetWindowText(temp);
	if(m_bit2.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit3.GetWindowText(temp);
	if(m_bit3.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit4.GetWindowText(temp);
	if(m_bit4.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit5.GetWindowText(temp);
	if(m_bit5.m_arquivo!="")frase+=temp;	frase+=" ";
	m_bit6.GetWindowText(temp);
	if(m_bit6.m_arquivo!="")frase+=temp;

	UpdateData();
// Prepara o texto para a impresso
	
	CDC m_dc;
	CPrintDialog    printDlg(FALSE);

// Janela da impressora
    if (printDlg.DoModal() == IDCANCEL)   return;
    
	m_dc.Attach(printDlg.GetPrinterDC());
    m_dc.m_bPrinting = TRUE; 
    
    DOCINFO di;
    ::ZeroMemory (&di, sizeof (DOCINFO));
    di.cbSize = sizeof (DOCINFO);    

// Ttulo do documento.
    di.lpszDocName = "Prancha Virtual";
	
// Comea a imprimir
    if(m_dc.StartDoc( &di) > 0){  
// Comea a pgina
		m_dc.StartPage();
		m_dc.SetMapMode(MM_HIMETRIC);
// Adiciona o texto
		CRect rectTexto;
		rectTexto.left=1000;
		rectTexto.top=-1000;
		rectTexto.right=18000;
		rectTexto.bottom =-3000;
		m_dc.DrawText(frase, &rectTexto,DT_NOPREFIX |DT_WORDBREAK);
// Fim da pgina e do documento
      m_dc.EndPage();
        m_dc.EndDoc(); 
	    }  
// Ocorreu um erro, cancela impresso
    else m_dc.AbortDoc();

// Acaba a impressso
    m_dc.Detach();    
	
}

void CPranchaVirtualDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	//***********************
	//	clique da direita	*
	//***********************

	// Exibe o menu

	if((m_grupoativo>0 && m_grupoativo<7)|| m_grupoativo==8 ){
		ClientToScreen(&point) ;
		HMENU hMenu = ::LoadMenu(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MENU2)) ;
		EnableMenuItem(hMenu,ID_EDITAR,MF_GRAYED);
		EnableMenuItem(hMenu,ID_APAGAR,MF_GRAYED);
		TrackPopupMenu(::GetSubMenu(hMenu, 0), MF_POPUP, point.x, point.y, 0, m_hWnd, NULL) ;
		//Menu("",1);
		}
	CDialog::OnRButtonDown(nFlags, point);
}

void CPranchaVirtualDlg::OnTimer(UINT nIDEvent) 
{
	//***************
	//	varreura	*
	//***************

// Executa tarefas com tempo determinado.
	
// Verifica a linha e colore a ativa
	CRect r;
	if(m_vpos==1){
		m_vhor++;
		if(m_vhor==1){
			m_b1.GetWindowRect(r);
			SetCursorPos(r.left+4,r.top+4);
			m_b13.SetCor(GetSysColor(COLOR_BTNFACE));m_b14.SetCor(GetSysColor(COLOR_BTNFACE));m_b15.SetCor(GetSysColor(COLOR_BTNFACE));
			m_b16.SetCor(GetSysColor(COLOR_BTNFACE));m_b17.SetCor(GetSysColor(COLOR_BTNFACE));m_b18.SetCor(GetSysColor(COLOR_BTNFACE));
				
			m_b1.SetCor(RGB(255,255,0));m_b2.SetCor(RGB(255,255,0));m_b3.SetCor(RGB(255,255,0));
			m_b4.SetCor(RGB(255,255,0));m_b5.SetCor(RGB(255,255,0));m_b6.SetCor(RGB(255,255,0));
			}
		else if(m_vhor==2){
			m_b7.GetWindowRect(r);
			SetCursorPos(r.left+4,r.top+4);
			m_b1.SetCor(GetSysColor(COLOR_BTNFACE));m_b2.SetCor(GetSysColor(COLOR_BTNFACE));m_b3.SetCor(GetSysColor(COLOR_BTNFACE));
			m_b4.SetCor(GetSysColor(COLOR_BTNFACE));m_b5.SetCor(GetSysColor(COLOR_BTNFACE));m_b6.SetCor(GetSysColor(COLOR_BTNFACE));
				
			m_b7.SetCor(RGB(255,255,0)); m_b8.SetCor(RGB(255,255,0)); m_b9.SetCor(RGB(255,255,0));
			m_b10.SetCor(RGB(255,255,0));m_b11.SetCor(RGB(255,255,0));m_b12.SetCor(RGB(255,255,0));
			}
		else if(m_vhor==3){
			m_b13.GetWindowRect(r);
			SetCursorPos(r.left+4,r.top+4);
			m_b7.SetCor(GetSysColor(COLOR_BTNFACE));m_b8.SetCor(GetSysColor(COLOR_BTNFACE));m_b9.SetCor(GetSysColor(COLOR_BTNFACE));
			m_b10.SetCor(GetSysColor(COLOR_BTNFACE));m_b11.SetCor(GetSysColor(COLOR_BTNFACE));m_b12.SetCor(GetSysColor(COLOR_BTNFACE));
				
			m_b13.SetCor(RGB(255,255,0));m_b14.SetCor(RGB(255,255,0));m_b15.SetCor(RGB(255,255,0));
			m_b16.SetCor(RGB(255,255,0));m_b17.SetCor(RGB(255,255,0));m_b18.SetCor(RGB(255,255,0));
			m_vhor=0;
			}
		}
	if(m_vpos==2){
		CRect r;
		CRect r2;
// Limpa as cores dos botes
		if(m_vhor==1){
			m_b1.GetWindowRect(r);
			m_b2.SetCor(GetSysColor(COLOR_BTNFACE));m_b3.SetCor(GetSysColor(COLOR_BTNFACE));
			m_b4.SetCor(GetSysColor(COLOR_BTNFACE));m_b5.SetCor(GetSysColor(COLOR_BTNFACE));m_b6.SetCor(GetSysColor(COLOR_BTNFACE));
			}
		else if(m_vhor==2){
			m_b7.GetWindowRect(r);
			m_b8.SetCor(GetSysColor(COLOR_BTNFACE));m_b9.SetCor(GetSysColor(COLOR_BTNFACE));
			m_b10.SetCor(GetSysColor(COLOR_BTNFACE));m_b11.SetCor(GetSysColor(COLOR_BTNFACE));m_b12.SetCor(GetSysColor(COLOR_BTNFACE));
			}
		else if(m_vhor==0){
			m_b13.GetWindowRect(r);
			m_b14.SetCor(GetSysColor(COLOR_BTNFACE));m_b15.SetCor(GetSysColor(COLOR_BTNFACE));
			m_b16.SetCor(GetSysColor(COLOR_BTNFACE));m_b17.SetCor(GetSysColor(COLOR_BTNFACE));m_b18.SetCor(GetSysColor(COLOR_BTNFACE));
			}
m_vver++;	
// Posiciona o cursor do mouse no boto
		if(m_vver==1){
			m_b7.GetWindowRect(r2);	SetCursorPos(r2.left+4,r.top+4);
			}
		else if(m_vver==2){
			m_b8.GetWindowRect(r2); SetCursorPos(r2.left+4,r.top+4);
			}
		else if(m_vver==3){
			m_b9.GetWindowRect(r2); SetCursorPos(r2.left+4,r.top+4);
			}
		else if(m_vver==4){
			m_b10.GetWindowRect(r2); SetCursorPos(r2.left+4,r.top+4);
			}
		else if(m_vver==5){
			m_b11.GetWindowRect(r2); SetCursorPos(r2.left+4,r.top+4);
			}
		else if(m_vver==6){
			m_b12.GetWindowRect(r2); SetCursorPos(r2.left+4,r.top+4);
			m_vver=0;
			}
		}
	
	CDialog::OnTimer(nIDEvent);
}

void CPranchaVirtualDlg::Predicao(int posicao)
{
	//***************************************
	//		Realiza a predio da imagem	*
	//***************************************

	bool trass=false;
	if(posicao>10){trass=true;posicao-=10;}//se maior de dez  porque est voltando

	CString imgdir="",imgesq="";
	int gesq,gdir,pesq,pdir;
	//p.Format("%d",posicao);

// Registra os 2s simbolos da frase
	if(posicao==1){                             m_bit1.GetWindowText(imgdir);}
	if(posicao==2){m_bit1.GetWindowText(imgesq);m_bit2.GetWindowText(imgdir);}
	if(posicao==3){m_bit2.GetWindowText(imgesq);m_bit3.GetWindowText(imgdir);}
	if(posicao==4){m_bit3.GetWindowText(imgesq);m_bit4.GetWindowText(imgdir);}
	if(posicao==5){m_bit4.GetWindowText(imgesq);m_bit5.GetWindowText(imgdir);}
	if(posicao==6){m_bit5.GetWindowText(imgesq);m_bit6.GetWindowText(imgdir);}

// Acha o grupo e posio pelo nome
	for(int g=1;g<=6;g++){
		int pos=0;
		do{
			pos++;
				if(grupo[g][pos].nome==imgdir){gdir=g;pdir=pos;}
				if(grupo[g][pos].nome==imgesq){gesq=g;pesq=pos;}
	
			}while(grupo[g][pos].nome.GetLength()>0);
		}
	
	CString k,l;

	imagem[13].caminho="";	imagem[14].caminho="";	imagem[15].caminho="";
	imagem[16].caminho="";	imagem[17].caminho="";	imagem[18].caminho="";

	if(posicao>1){
// Procura o histrico da DIREITA
		CString x;
		x.Format("%d",grupo[gdir][pdir].contador);
		CString clas,ncod;
		ncod.Format("%d",grupo[gdir][pdir].codigo);

		if(m_grupoativo==1)clas="a";
		if(m_grupoativo==2)clas="b";
		if(m_grupoativo==3)clas="c";
		if(m_grupoativo==4)clas="d";
		if(m_grupoativo==5)clas="e";
		if(m_grupoativo==6)clas="f";

		CString novo=clas;
		novo+=ncod+" ";


// Adiciona a ESQUERDA NOVO no histrico da DIREITA
		if(trass==false){
			if(grupo[gesq][pesq].historico.Find(novo,0)<0 && (m_grupoativo>0 && m_grupoativo<8)){//o novo no contm no histrico
				if(grupo[gdir][pdir].contador>=imagem[13].contador ){
					grupo[gesq][pesq].historico=novo;			grupo[gesq][pesq].historico+=pre[1].tudo;
					grupo[gesq][pesq].historico+=pre[2].tudo;	grupo[gesq][pesq].historico+=pre[3].tudo;
					grupo[gesq][pesq].historico+=pre[4].tudo;	grupo[gesq][pesq].historico+=pre[5].tudo;
					}
				else if(grupo[gdir][pdir].contador>=imagem[14].contador && (grupo[gdir][pdir].contador<imagem[13].contador || imagem[13].contador==0)){
					grupo[gesq][pesq].historico=pre[1].tudo;	grupo[gesq][pesq].historico+=novo;
					grupo[gesq][pesq].historico+=pre[2].tudo;	grupo[gesq][pesq].historico+=pre[3].tudo;
					grupo[gesq][pesq].historico+=pre[4].tudo;	grupo[gesq][pesq].historico+=pre[5].tudo;
					}
				else if(grupo[gdir][pdir].contador>=imagem[15].contador && (grupo[gdir][pdir].contador<imagem[14].contador || imagem[14].contador==0)){
					grupo[gesq][pesq].historico=pre[1].tudo;	grupo[gesq][pesq].historico+=pre[2].tudo;
					grupo[gesq][pesq].historico+=novo;			grupo[gesq][pesq].historico+=pre[3].tudo;
					grupo[gesq][pesq].historico+=pre[4].tudo;	grupo[gesq][pesq].historico+=pre[5].tudo;
					}
				else if(grupo[gdir][pdir].contador>=imagem[16].contador && (grupo[gdir][pdir].contador<imagem[15].contador || imagem[15].contador==0)){
					grupo[gesq][pesq].historico=pre[1].tudo;	grupo[gesq][pesq].historico+=pre[2].tudo;
					grupo[gesq][pesq].historico+=pre[3].tudo;	grupo[gesq][pesq].historico+=novo;
					grupo[gesq][pesq].historico+=pre[4].tudo;	grupo[gesq][pesq].historico+=pre[5].tudo;
					}
				else if(grupo[gdir][pdir].contador>=imagem[17].contador && (grupo[gdir][pdir].contador<imagem[16].contador || imagem[16].contador==0)){
					grupo[gesq][pesq].historico=pre[1].tudo;	grupo[gesq][pesq].historico+=pre[2].tudo;
					grupo[gesq][pesq].historico+=pre[3].tudo;	grupo[gesq][pesq].historico+=pre[4].tudo;
					grupo[gesq][pesq].historico+=novo;			grupo[gesq][pesq].historico+=pre[5].tudo;
					}
				else if(grupo[gdir][pdir].contador>=imagem[18].contador || imagem[17].contador==0){
					grupo[gesq][pesq].historico=pre[1].tudo;	grupo[gesq][pesq].historico+=pre[2].tudo;
					grupo[gesq][pesq].historico+=pre[3].tudo;	grupo[gesq][pesq].historico+=pre[4].tudo;
					grupo[gesq][pesq].historico+=pre[5].tudo;	grupo[gesq][pesq].historico+=novo;
					}
				grupo[gesq][pesq].historico.TrimRight();
				}
			else{//j contm no histrico
// Reposiciona a ESQUERDA  no histrico da DIREITA
				if(grupo[gdir][pdir].nome==imagem[14].nome && grupo[gdir][pdir].contador>=imagem[13].contador ){
					grupo[gesq][pesq].historico=pre[2].tudo;//
					grupo[gesq][pesq].historico+=pre[1].tudo;//
					grupo[gesq][pesq].historico+=pre[3].tudo;	grupo[gesq][pesq].historico+=pre[4].tudo;
					grupo[gesq][pesq].historico+=pre[5].tudo;	grupo[gesq][pesq].historico+=pre[6].tudo;
					}
				if(grupo[gdir][pdir].nome==imagem[15].nome && grupo[gdir][pdir].contador>=imagem[14].contador ){
					grupo[gesq][pesq].historico=pre[1].tudo;
					grupo[gesq][pesq].historico+=pre[3].tudo;//
					grupo[gesq][pesq].historico+=pre[2].tudo;//
					grupo[gesq][pesq].historico+=pre[4].tudo;	grupo[gesq][pesq].historico+=pre[5].tudo;
					grupo[gesq][pesq].historico+=pre[6].tudo;
					}
				if(grupo[gdir][pdir].nome==imagem[16].nome && grupo[gdir][pdir].contador>=imagem[15].contador ){
					grupo[gesq][pesq].historico=pre[1].tudo;	grupo[gesq][pesq].historico+=pre[2].tudo;
					grupo[gesq][pesq].historico+=pre[4].tudo;//
					grupo[gesq][pesq].historico+=pre[3].tudo;//
					grupo[gesq][pesq].historico+=pre[5].tudo;	grupo[gesq][pesq].historico+=pre[6].tudo;

					}
				if(grupo[gdir][pdir].nome==imagem[17].nome && grupo[gdir][pdir].contador>=imagem[16].contador ){
					grupo[gesq][pesq].historico=pre[1].tudo;	grupo[gesq][pesq].historico+=pre[2].tudo;
					grupo[gesq][pesq].historico+=pre[3].tudo;
					grupo[gesq][pesq].historico+=pre[5].tudo;//
					grupo[gesq][pesq].historico+=pre[4].tudo;//
					grupo[gesq][pesq].historico+=pre[6].tudo;
					}
				
				if(grupo[gdir][pdir].nome==imagem[18].nome && grupo[gdir][pdir].contador>=imagem[17].contador ){
					grupo[gesq][pesq].historico=pre[1].tudo;	grupo[gesq][pesq].historico+=pre[2].tudo;
					grupo[gesq][pesq].historico+=pre[3].tudo;	grupo[gesq][pesq].historico+=pre[4].tudo;
					grupo[gesq][pesq].historico+=pre[6].tudo;//
					grupo[gesq][pesq].historico+=pre[5].tudo;//
					}
				grupo[gesq][pesq].historico.TrimRight();
				}
				 
			}
	}
	//mostra a lista de predio

	CString historico=grupo[gdir][pdir].historico;
	CString historico2=grupo[gdir][pdir].historico;

//MessageBox(grupo[gesq][pesq].historico+"-");	
	
// Pesquisa todos os 6 simbolos do historico
	for(int i=6;i>=1;i--){
		pre[i].nome="";
		pre[i].caminho="";
		pre[i].contador=0;
		pre[i].achou=false;
		historico.Delete(0,historico.ReverseFind(' ')+1);
		historico2.Delete(historico2.ReverseFind(' '),historico2.GetLength()-historico2.ReverseFind(' '));
		CString classe,cod;
		classe=historico;
		classe.Delete(1,classe.GetLength()-1);
// Grupo
		pre[i].grupo=classe;
		cod=historico;
		cod.Delete(0,1);
// Codigo
		pre[i].codigo=cod;
		pre[i].tudo=classe;
		pre[i].tudo+=cod;
		pre[i].tudo+=" ";
		
		int g=0;
		if(classe=="a")g=1;	if(classe=="b")g=2;	if(classe=="c")g=3;
		if(classe=="d")g=4;	if(classe=="e")g=5;	if(classe=="f")g=6;
		if(classe=="0"){
			pre[i].contador=0;
			}
		else{
			int pos=1;
			pre[i].achou=false;
			do{
				if(grupo[g][pos].codigo==atoi(cod)){
					pre[i].nome=grupo[g][pos].nome;
					pre[i].caminho=grupo[g][pos].caminho;
					pre[i].contador=grupo[g][pos].contador;
					pre[i].achou=true;
					}
				pos++;
				}while(grupo[g][pos].nome.GetLength()>0);
			}
		historico=historico2;
		}
			
	CString zz;

//	Caso tenha sido apagado, ele reorganiza os smbolos
	if(pre[6].achou==false){
		pre[6].tudo="00 ";
//		MessageBox("pre6");
		}
	if(pre[5].achou==false){
		pre[5].tudo=pre[6].tudo;	pre[6].tudo="00 ";
//		MessageBox("pre5");
		}
	if(pre[4].achou==false){
		pre[4].tudo=pre[5].tudo;	pre[5].tudo=pre[6].tudo;
		pre[6].tudo="00 ";
//		MessageBox("pre4");
		}
	if(pre[3].achou==false){
		pre[3].tudo=pre[4].tudo;	pre[4].tudo=pre[5].tudo;
		pre[5].tudo=pre[6].tudo;	pre[6].tudo="00 ";
//		MessageBox("pre3");
		}
	if(pre[2].achou==false){
		pre[2].tudo=pre[3].tudo;	pre[3].tudo=pre[4].tudo;
		pre[4].tudo=pre[5].tudo;	pre[5].tudo=pre[6].tudo;
		pre[6].tudo="00 ";
//		MessageBox("pre2");
		}
	if(pre[1].achou==false){
		pre[1].tudo=pre[2].tudo;	pre[2].tudo=pre[3].tudo;
		pre[3].tudo=pre[4].tudo;	pre[4].tudo=pre[5].tudo;
		pre[5].tudo=pre[6].tudo;	pre[6].tudo="00 ";
//		MessageBox("pre1");
		}
	
	grupo[gdir][pdir].historico=pre[1].tudo;
	grupo[gdir][pdir].historico+=pre[2].tudo;
	grupo[gdir][pdir].historico+=pre[3].tudo;
	grupo[gdir][pdir].historico+=pre[4].tudo;
	grupo[gdir][pdir].historico+=pre[5].tudo;
	grupo[gdir][pdir].historico+=pre[6].tudo;
	grupo[gdir][pdir].historico.TrimRight();
//	MessageBox(grupo[gdir][pdir].historico);

//se for vazio, apaga da tela
	int t=12;
	for(int w=1;w<=6;w++){
		imagem[t+w].caminho=pre[w].caminho;
		imagem[t+w].nome=    pre[w].nome;
		imagem[t+w].contador=pre[w].contador;
		if(imagem[t+w].caminho==""){
			t--;
			}
		}
}

BOOL CPranchaVirtualDlg::PreTranslateMessage(MSG* pMsg) 
{
	//***********************************
	//	Monitora os eventos da janela	*
	//***********************************

// Se pressionar [F1], exibe ao arquivo ajuda.chm

	if(config.varredura==false && pMsg->message == WM_KEYDOWN && pMsg->wParam== VK_F1){
		WinExec("hh.exe "+m_diretorio+"AjudaPrancha.chm" ,SW_SHOW);
				}
// Se a varredura estiver ativada, qualquer toque no teclado muda o estado da varredura
	if(config.varredura==true){
			
		if (pMsg->message == WM_CHAR && m_vpos==2) {
			KillTimer(1);
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0); 
			mouse_event(MOUSEEVENTF_LEFTUP  , 0, 0, 0, 0); 
			m_vpos=1;
			m_vhor=0;
			m_vver=0;
			SetTimer(1,config.atraso*1000,0);
			}
		else if (pMsg->message == WM_CHAR && m_vpos==1){
			m_vpos=2;
			}
		}

	return CDialog::PreTranslateMessage(pMsg);
}

void CPranchaVirtualDlg::Resolucao(int lar,int alt) 
{
	//*******************************************
	// Seta a resoluo da tela para 800x600	*
    //*******************************************
	DEVMODE dss; 
    memset(&dss,0,sizeof(dss));  
    dss.dmSize=sizeof(dss);
	
// Largura da tela
    dss.dmPelsWidth = lar;           

// Altura da tela
    dss.dmPelsHeight = alt;
    dss.dmBitsPerPel = 32; 
    dss.dmFields = DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT; 
	ChangeDisplaySettings(&dss,0);	
}
bool CPranchaVirtualDlg::SintetizadorAbrir(CString frase)
{

// Fecha o sintetizador
	SintetizadorFechar();

	TTSMODEINFO TTSModeInfo;
	TTSMODEINFO ttsmiTemp; 
	PITTSFIND pITTSFind;  

// inicializa o OLE
	if (FAILED(CoInitialize(NULL)))return false;

// Cria o objeto Multimedia Audio Destination
	if (FAILED(CoCreateInstance(CLSID_MMAudioDest, NULL, CLSCTX_ALL, IID_IAudioMultiMediaDevice, (void**) &pIAMM)))
		return false;
	pIAMM->DeviceNumSet(WAVE_MAPPER);

// Cria o enumerador do Text-To-Speech
	if (FAILED(CoCreateInstance(CLSID_TTSEnumerator, NULL, CLSCTX_ALL,IID_ITTSFind, (void**) &pITTSFind))){
		pIAMM->Release();
		return false;
		}
	ZeroMemory(&ttsmiTemp, sizeof(ttsmiTemp));

// Define o idioma (portugus)	
	ttsmiTemp.language.LanguageID = MAKELANGID(LANG_PORTUGUESE, SUBLANG_PORTUGUESE_BRAZILIAN);

// Define o tipo de voz Masculina ou Feminina
	if(config.masculino==1)ttsmiTemp.wGender = GENDER_FEMALE;
	else ttsmiTemp.wGender = GENDER_MALE;
	ttsmiTemp.wAge = TTSAGE_ADULT;
	
// Encontra o engine baseado nas configuraes,acima
	if (FAILED(pITTSFind->Find(&ttsmiTemp, NULL, &TTSModeInfo))){
		pIAMM->Release();
		pITTSFind->Release();
		return false;			
		}
// Seleciona o modo Text-To-Speech
	if (FAILED(pITTSFind->Select(TTSModeInfo.gModeID, &pITTSCentral, (LPUNKNOWN) pIAMM))){
		pIAMM->Release();
		pITTSFind->Release();
		return false;
		}
	pITTSFind->Release();
	SDATA sdata;

// Faz a montagem do texto
	int tam = frase.GetLength();
	sdata.dwSize=tam+1;
	sdata.pData = (CHAR *) malloc( sdata.dwSize);
	strcpy((CHAR*)sdata.pData, frase);

// Envia o texto para o engine
	if (FAILED(pITTSCentral->TextData(CHARSET_TEXT , 0, sdata, NULL, IID_ITTSBufNotifySinkW))){
		return false;
		}
	sintativo=true;
// libera
	free(sdata.pData);
// Retorna true, para no enviar a mensagem de erro
	return true;
}
void CPranchaVirtualDlg::SintetizadorFechar()
{
	//***************************
	// Fecha o sintetizador		*	
	//***************************

	if ( pIAMM ) {
		pIAMM->Release();
		pIAMM = NULL;
		}
	if ( pITTSCentral ) {
		pITTSCentral->Release();
		pITTSCentral = NULL;
		}

}

void CPranchaVirtualDlg::UsuConf(CString usuario) 
{
	//*******************************************
	//	configurao de cada pasta de usurio	*
	//*******************************************

	UpdateData();

	CString pasta=m_diretorio;
	TCHAR temp[500] = {0}; //   [Ttulo] texto =  texto2 ,var,tam,   arquivo
	pasta+=usuario;
	pasta+="\\config.ini";

// Pega as configuraes do arquivo config.ini
	GetPrivateProfileString("Configuraes da Prancha Virtual","autoclique","0",temp,500,pasta);
	config.autoclique=atoi(temp);

	GetPrivateProfileString("Configuraes da Prancha Virtual","varredura","0",temp,500,pasta);
	config.varredura=atoi(temp);
		
	GetPrivateProfileString("Configuraes da Prancha Virtual","tempo"   ,"4"  ,temp,500,pasta);
	config.atraso=atoi(temp);
		
	GetPrivateProfileString("Configuraes da Prancha Virtual","fundo"  ,"",temp,500,pasta);
	config.fundo=temp;

	GetPrivateProfileString("Configuraes da Prancha Virtual","tipo"   ,"Centro",temp,500,pasta);
	config.tipo=temp;

	GetPrivateProfileString("Configuraes da Prancha Virtual","cor"    ,"",temp,500,pasta);
	sscanf(temp, "%08X", &config.cor);

	GetPrivateProfileString("Configuraes da Prancha Virtual","legenda","1",temp,500,pasta);
	config.legenda=atoi(temp);

	GetPrivateProfileString("Configuraes da Prancha Virtual","som","0",temp,500,pasta);
	config.som=atoi(temp);

	GetPrivateProfileString("Configuraes da Prancha Virtual","homem","1",temp,500,pasta);
	config.masculino=atoi(temp);

// Abre os smbolos do sistema
	CFile arquivo;
	if(arquivo.Open(m_diretorio+usuario+"\\interface.cfg",CFile::modeRead)){//abre  arquivo
		CString ptemp;
		CString temp="";
		int tam=0;
		int q=1;
		tam = arquivo.GetLength();
		char *texto=new char[tam];
		int bytesRead = arquivo.Read(texto,tam);
		texto [bytesRead] = 0;
		for(int i=0;i<tam;i++){
			if(texto[i]=='\n'){
				temp=ptemp;
				temp.Delete(temp.ReverseFind('*'),temp.GetLength()-temp.ReverseFind('*'));
				imagem[q].nome=temp;
				temp=ptemp;
				temp.Delete(0,temp.ReverseFind('*')+1);
				if(q<13 || q>18){
					if(temp.Find(":\\",1)<0){
 						imagem[q].caminho=m_desktop;
 						imagem[q].caminho+="\\Imagens da Prancha\\";
 						imagem[q].caminho+=temp;
						}
					else
 						imagem[q].caminho=temp;
					}
//			MessageBox(temp);
				q++;
				ptemp="";
				}
			else if (texto[i+1]!='\n'){ 
				ptemp+=texto[i];
				}
			}
//		if(ptemp.GetLength()>0)imagem[q].caminho;

		}
	else{
		CreateDirectory(m_diretorio+usuario,NULL);
		arquivo.Open(m_diretorio+usuario+"\\interface.cfg",CFile::modeCreate | CFile::modeWrite);//Cria o arquivo
		arquivo.SetLength(0);
		CString string2="";
		arquivo.Write(string2,string2.GetLength());
		}
	arquivo.Close();

// Abre os smbolos de cada grupo
	CFile arquivo2;
	CString grupo2;
	for(int j=1;j<=6;j++){
		if(j==1)grupo2="\\grupo1.cfg";
		if(j==2)grupo2="\\grupo2.cfg";
		if(j==3)grupo2="\\grupo3.cfg";
		if(j==4)grupo2="\\grupo4.cfg";
		if(j==5)grupo2="\\grupo5.cfg";
		if(j==6)grupo2="\\grupo6.cfg";
		int q=1;
		if(arquivo2.Open(m_diretorio+usuario+grupo2,CFile::modeRead)){//abre  arquivo
//			MessageBox(m_diretorio+usuario+grupo2);
			CString ptemp;
			CString temp="";
			int tam=0;
			tam = arquivo2.GetLength();
			char *texto=new char[tam];
			int bytesRead = arquivo2.Read(texto,tam);
			texto [bytesRead] = 0;
			for(int i=0;i<tam;i++){
				if(texto[i]=='\n'){
					temp=ptemp;
					temp.Delete(temp.Find(" ",0), temp.GetLength()-temp.Find(" ",0));
					grupo[j][q].codigo=atoi(temp);
// Cdigo
					temp=ptemp;


					temp.Delete(temp.Find("-",temp.Find(" ",temp.Find(" ",0)+1)), temp.GetLength()-temp.Find("-",temp.Find(" ",temp.Find(" ",0)+1)));
//MessageBox(temp);
					temp.Delete(temp.ReverseFind(' '),temp.GetLength()-temp.ReverseFind(' '));
					//temp.Delete(temp.Find(" ",temp.Find(" ",0)+1), temp.GetLength()-temp.Find(" ",temp.Find(" ",0)+1));
					temp.Delete(0,temp.Find(" ")+1);										
					grupo[j][q].nome=temp;
// Nome
					temp=ptemp;
					temp.Delete(temp.Find("-",0), temp.GetLength()-temp.Find("-",0));
					temp.Delete(0,temp.ReverseFind(' '));
					temp.Delete(0,temp.Find(" ")+1);										
					temp.Delete(0,temp.Find(" ")+1);										
					grupo[j][q].contador=atoi(temp);
// Contador
					temp=ptemp;
					temp.Delete(temp.ReverseFind('*'), temp.GetLength()-temp.ReverseFind('*'));
					temp.Delete(0, temp.ReverseFind('-')+1);
					grupo[j][q].historico=temp;
// Histrico
					temp=ptemp;
					temp.Delete(0,temp.ReverseFind('*')+1);
					if(temp.Find(":\\",1)<0){
 						grupo[j][q].caminho=m_desktop;
						grupo[j][q].caminho+="\\Imagens da Prancha\\";
						grupo[j][q].caminho+=temp;
						}
					else
						grupo[j][q].caminho=temp;
// Caminho
					q++;
					ptemp="";
					}
				else if (texto[i+1]!='\n'){ 
					ptemp+=texto[i];
					}
				}
			if(ptemp.GetLength()>0){

				temp=ptemp;
//	Tudo
				temp.Delete(temp.Find(" ",0), temp.GetLength()-temp.Find(" ",0));
				grupo[j][q].codigo=atoi(temp);
//	Cdigo
				temp=ptemp;
				temp.Delete(temp.Find("-"), temp.GetLength()-temp.Find("-"));
				temp.Delete(temp.ReverseFind(' '),temp.GetLength()-temp.ReverseFind(' '));
				//temp.Delete(temp.Find(" ",temp.Find(" ",0)+1), temp.GetLength()-temp.Find(" ",temp.Find(" ",0)+1));
				temp.Delete(0,temp.Find(" ")+1);										
				grupo[j][q].nome=temp;
//	Nome
				temp=ptemp;
				temp.Delete(temp.Find("-",0), temp.GetLength()-temp.Find("-",0));
				temp.Delete(0,temp.ReverseFind(' '));
				temp.Delete(0,temp.Find(" ")+1);										
				temp.Delete(0,temp.Find(" ")+1);										
				grupo[j][q].contador=atoi(temp);
//	contador
				temp=ptemp;
				temp.Delete(0,temp.Find("-",0)+1);
				temp.Delete(temp.ReverseFind('-'),temp.GetLength()-temp.ReverseFind('-'));
				grupo[j][q].historico=temp;
//	Histrico
				temp=ptemp;
				temp.Delete(0,temp.ReverseFind('-')+1);
				if(temp.Find(":\\",1)<0){
					grupo[j][q].caminho=m_desktop;
					grupo[j][q].caminho+="\\Imagens da Prancha\\";
					grupo[j][q].caminho+=temp;
					}
				else
					grupo[j][q].caminho=temp;
//	Caminho
				}

			do{
				CString h;
				h.Format("%d",q);
//				MessageBox(h);
				grupo[j][q].caminho="";
				grupo[j][q].nome="";
				q++;
				}while(grupo[j][q+1].caminho.GetLength()>0);
			grupo[j][q].caminho="";
			grupo[j][q].nome="";
				
			}
		else{
			CreateDirectory(m_diretorio+usuario,NULL);
			arquivo2.Open(m_diretorio+usuario+grupo2,CFile::modeCreate | CFile::modeWrite);//Cria o arquivo
			arquivo2.SetLength(0);
			CString string2="";
			arquivo2.Write(string2,string2.GetLength());
			}//if(arquivo2.Open(usuario[1].nome+grupo2,CFile::modeRead)){//abre  arquivo
		arquivo2.Close();

	}//for(int j=1;j<=6;j++){
	if(config.varredura==1){SetTimer(1,config.atraso*1000,0);}
	else KillTimer(1);;
 

}

void CPranchaVirtualDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPranchaVirtualDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPranchaVirtualDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
 
