/*
Prancha Livre de Comunicao
Copyright (C) 2005 Percy Nohama <percy@ppgia.pucpr.br>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#if !defined(AFX_BUTTON2_H__E9E3B135_187A_45F5_87D3_84835311FC71__INCLUDED_)
#define AFX_BUTTON2_H__E9E3B135_187A_45F5_87D3_84835311FC71__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Button2.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CButton2 window

class CButton2 : public CButton
{
// Construction
public:
	CButton2();

// Attributes
public:

 	BOOL        m_aberto;	// Aberto ou no a imagem
	CString		m_arquivo;	// Nome da Imagem
	BOOL		m_cima;		// Estado sobre do mouse sobre o boto
	BOOL		m_movendo;	// Movendo o mouse
	COLORREF	m_corFundo;	// Cor de Fundo
 	
	void SetImagem(CString arquivo);					// Abre a Imagem
	void SetCor(COLORREF clrBackground);				// Seta a cor do boto

	void OnMouseMove(UINT nFlags, CPoint point);		// Evento de movimento do mouse
	void OnMouseHover(WPARAM wparam, LPARAM lparam) ;	// Mouise passa sobre o hoto
	LRESULT OnMouseLeave(WPARAM wparam, LPARAM lparam);	// Mouse deixa o boto

	void MenuInserir();// Menus referentes a aes pelo boto direito do mouse
	void MenuEditar();
	void MenuApagar();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CButton2)
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);// Desenha o boto
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CButton2();

	// Generated message map functions
protected:
	//{{AFX_MSG(CButton2)
	afx_msg void OnTimer(UINT nIDEvent);					// Contador de temp para o autoclique
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);	// Boto direito do mouse
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BUTTON2_H__E9E3B135_187A_45F5_87D3_84835311FC71__INCLUDED_)
