/*
Prancha Livre  de Comunicao
Copyright (C) 2005 Percy Nohama <percy@ppgia.pucpr.br>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// OpcaoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PranchaVirtual.h"
#include "OpcaoDlg.h"
#include "PranchaVirtualDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpcaoDlg dialog


COpcaoDlg::COpcaoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COpcaoDlg::IDD, pParent)
{
	//***********************
	//*		Construtor		*
	//***********************

	// Inicializa as variveis

	m_confirmar=false;
	//{{AFX_DATA_INIT(COpcaoDlg)
	//}}AFX_DATA_INIT
}


void COpcaoDlg::DoDataExchange(CDataExchange* pDX)
{
	//************************************************************
	//	Associa o ID dos componentes grficos com a varivel	 *
	//************************************************************

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpcaoDlg)
	DDX_Control(pDX, IDC_EDIT1, m_cedit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COpcaoDlg, CDialog)
	//************************************************************
	//*	Associa o ID dos componentes grficos com a funo		 *
	//************************************************************

	//{{AFX_MSG_MAP(COpcaoDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnMenos)
	ON_BN_CLICKED(IDC_BUTTON2, OnMais)
	ON_BN_CLICKED(IDOK, OnConfirmar)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpcaoDlg message handlers


void COpcaoDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	//*******************************************	
	//*	Inicia a tela da configurao do tempo	*
	//*******************************************

	CDialog::OnShowWindow(bShow, nStatus);

	CString temp;
// Pega o valor do atraso
	temp.Format("%d",((CPranchaVirtualDlg*)GetParent())->config.atraso);
	m_cedit.SetWindowText(temp);
	
}
void COpcaoDlg::OnMenos() 
{
	//***********************************	
	//*	Diminui o tempo de autoclique	*
	//***********************************

	if(((CPranchaVirtualDlg*)GetParent())->config.atraso>1){
// Diminui o valor
		((CPranchaVirtualDlg*)GetParent())->config.atraso--;
		CString temp;
		temp.Format("%d",((CPranchaVirtualDlg*)GetParent())->config.atraso);
// Atualiza na janela
		m_cedit.SetWindowText(temp);
		}
}
void COpcaoDlg::OnMais() 
{
	//***********************************
	//* Aumenta o tempo de autoclique	*
	//***********************************

	if(((CPranchaVirtualDlg*)GetParent())->config.atraso<10){
// Aumenta o valor
		((CPranchaVirtualDlg*)GetParent())->config.atraso++;
		CString temp;
		temp.Format("%d",((CPranchaVirtualDlg*)GetParent())->config.atraso);
// Atualiza na janela
		m_cedit.SetWindowText(temp);
		}	
}

void COpcaoDlg::OnConfirmar() 
{
	//***********************************
	//* Confirma e fecha a janela		*
	//***********************************

	m_confirmar=true;

	CWnd *a;
// Pega a janela ativa e fecha
	a=CWnd::GetActiveWindow();
	a->SendMessage(WM_CLOSE);

}
