/*
Prancha Livre de Comunicao
Copyright (C) 2005 Percy Nohama <percy@ppgia.pucpr.br>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// Static2.cpp : implementation file
//

#include "stdafx.h"
#include "PranchaVirtual.h"

#include "PranchaVirtualDlg.h"
#include "Static2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define UPDATE_ENTIRE_CLIENT_AREA
/////////////////////////////////////////////////////////////////////////////
// CStatic2

CStatic2::CStatic2()
{
  	//***********************
	//*		Construtor		*
	//***********************

	// Inicializa as variveis
  
}

CStatic2::~CStatic2()
{
	//***********************
	//*		Destrutor		*
	//***********************

}

BEGIN_MESSAGE_MAP(CStatic2, CStatic)
 	//************************************************************
	//*	Associa o ID dos componentes grficos com a funo		 *
	//************************************************************

   //{{AFX_MSG_MAP(CStatic2)
    ON_WM_ERASEBKGND()
    ON_WM_DRAWITEM_REFLECT()
    ON_WM_SYSCOLORCHANGE()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatic2 message handlers

 
void CStatic2::SetImagem(CString nome)
{

	//*******************
	//	Testa a figura	*
	//*******************

	CFile arquivo;
// Se conseguir abrir a figura
	if (arquivo.Open(nome,CFile::modeRead)){
		m_arquivo=nome;
		m_aberto=true;
		arquivo.Close();
// desenha a figura
		}
	else {
		m_aberto=false;
// desenha o erro
		}
}
 


void CStatic2::PreSubclassWindow() 
{
	//***************************************/
	//	Modifica o estilo para Ownerdraw	*/
	//***************************************/

    CStatic::PreSubclassWindow();
    ModifyStyle(0, SS_OWNERDRAW);
}

BOOL CStatic2::OnEraseBkgnd(CDC* pDC) 
{
	//***********************/
	//	Desenha a Imagem	*/
	//***********************/
	// Desenha uma IMAGEM VLIDA
	if(m_aberto==true){
// Acerta o tamanho
		CRect rect;
		rect.top=0;
		rect.left=0;
		rect.right=((CPranchaVirtualDlg*)GetParent())->tela.lar;
		rect.bottom=((CPranchaVirtualDlg*)GetParent())->tela.alt*0.85;

		// adiciona a imagem
		((CPranchaVirtualDlg*)GetParent())->Imagem(pDC,m_arquivo, rect);

		}
		
    return TRUE;
}

void CStatic2::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	//***********************/
	//	Redesenha a imagem 	*/
	//***********************/

    ASSERT(lpDrawItemStruct != NULL);

    CString texto;
    GetWindowText(texto);
    if (texto.GetLength()<=0) return;

    CDC*  pDC     = CDC::FromHandle(lpDrawItemStruct->hDC);
    CRect rect    = lpDrawItemStruct->rcItem;
    DWORD dwStyle = GetStyle();
     
    int nOldMode = pDC->SetBkMode(TRANSPARENT);
	int alt=((CPranchaVirtualDlg*)GetParent())->tela.alt;
	rect.top=alt*0.9;

// Verifica o tamnho da imagem
	if(((CPranchaVirtualDlg*)GetParent())->config.legenda==false){
			rect.top=200;
		}
	if(m_aberto==true)pDC->DrawText(texto, rect, DT_CENTER);

    pDC->SetBkMode(nOldMode);

}
 
